/*
 * Algorithm.java
 *
 * Created on Utorok, 2008, aprl 1, 12:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm;

import form.AlgorithmForm;
import graphics.StandardVisualization;
import graphics.StandardVisualizationData;
import graphics.Visualization;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import javax.swing.JFrame;
import network.Network;
import other.Global;

/**
 *
 * @author Dur
 */
public class Algorithm implements Serializable
{
  protected SourceCode sourceCode;
  protected Visualization visualization;
  public String name="algorithm";
  public int activatedVisualizationDataIndex=0;
  public Network[] networks;
  public int index, type;
  public StandardVisualizationData[] visualizationData=new StandardVisualizationData[0];
  
  public Network CreateNetwork(Algorithm alg)
  {
    return new Network(alg);
  }
  
  public SourceCode CreateSourceCode()
  {
    return new SourceCode();
  }
  
  public Visualization CreateVisualization()
  {
    return new StandardVisualization();
  }
  
  public String[] GetNetworkList()
  {
    String[] res=new String[networks.length];
    for (int i=0;i<networks.length;i++)
    {
      res[i]=networks[i].GetName();
    }
    return res;
  }
  
  public void DeleteNetwork(int index)
  {
    Network[] net=new Network[networks.length-1];
    if ((index>=0) && (index<networks.length))
    {
      int n=0;
      for (int i=0;i<networks.length;i++)
      {
        if (i!=index) 
        {
          net[n]=networks[i];
          n++;
        }
      }
    }
    networks=net;
  }
  
  public Network NewNetwork()
  {
    Network[] net=new Network[networks.length+1];
    System.arraycopy(networks,0,net,0,networks.length);
    net[net.length-1]=CreateNetwork(this);
    networks=net;
    return networks[networks.length-1];
  }
  
  public SourceCode GetSourceCode()
  {
    return sourceCode;
  }
  
  public Visualization GetVisualization()
  {
    return visualization;
  }
  
  public StandardVisualizationData GetActivatedVisualizationData()
  {
    if ((activatedVisualizationDataIndex>=0) && (activatedVisualizationDataIndex<visualizationData.length))
    {
      return visualizationData[activatedVisualizationDataIndex];
    }
    return null;
  }
  
  /** Creates a new instance of Algorithm */
  public Algorithm() {
    networks=new Network[1];
    networks[0]=CreateNetwork(this);
    sourceCode=CreateSourceCode();
    visualization=CreateVisualization();
    visualizationData=new StandardVisualizationData[1];
    visualizationData[0]=new StandardVisualizationData();
  }
  
  public void OpenPropertiesForm(JFrame caller)
  {
    AlgorithmForm frm=new AlgorithmForm(caller,this);
    frm.setVisible(true);
  }
  
  public void Repair()
  {
    if (GetVisualization() instanceof StandardVisualization)
    {
      ((StandardVisualization)GetVisualization()).Repair();
    }
    for (int k=0;k<networks.length;k++)
    {
      for (int l=0;l<networks[k].links.length;l++)
      {
        networks[k].links[l].Repair();
      }
    }
  }
  
  public Algorithm GetCopy()
  {
    try
    {
      Algorithm res=new Algorithm();
      ByteArrayOutputStream os=new ByteArrayOutputStream();
      ObjectOutputStream oos=new ObjectOutputStream(os);
      oos.writeObject(this);
      ByteArrayInputStream is=new ByteArrayInputStream(os.toByteArray());
      ObjectInputStream ois=new ObjectInputStream(is);
      res=(Algorithm)ois.readObject();
      res.Repair();
      oos.close();
      os.close();
      ois.close();
      is.close();
      return res;
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Error: algorithm->Algorithm->GetCopy", e);
    }
    return this;
  }
  
}
