/*
 * AlgorithmsCollection.java
 *
 * Created on Utorok, 2008, aprl 1, 13:03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import network.LinkMessage;
import other.*;

/**
 *
 * @author Dur
 */
public class AlgorithmsCollection implements Serializable
{
  private Algorithm[][] algorithms=new Algorithm[1][1];
  private String[] collectionNames=new String[]{"Algorithm collection 1"};
  
  /**
   * Creates a new instance of AlgorithmsCollection
   */  
  
  public static AlgorithmsCollection CreateAlgorithmsCollection()
  {
    try
    {
      File file=new File(Configuration.algorithmFile);
      if (file.exists())
      {
        FileInputStream fis=new FileInputStream(file);
        ObjectInputStream ois=new ObjectInputStream(fis);
        AlgorithmsCollection res=null;
        res=(AlgorithmsCollection) ois.readObject();
        Configuration.javaCompilerPath=(String)ois.readObject();
        ois.close();
        fis.close();
        res.Repair();
        return res;
      }
    }
    catch (Exception e){}
    return new AlgorithmsCollection();
  }
  
  private AlgorithmsCollection() {
    algorithms[0][0]=new Algorithm();
  }
  
  public void Save()
  {
    try
    {
      FileOutputStream fos=new FileOutputStream(Configuration.algorithmFile);
      ObjectOutputStream oos=new ObjectOutputStream(fos);
      oos.writeObject(this);
      oos.writeObject(Configuration.javaCompilerPath);
      oos.close();
      fos.close();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  
  public void Repair()
  {
    LinkMessage.Repair();
    for (int i=0;i<algorithms.length;i++)
    {
      for (int j=0;j<algorithms[i].length;j++)
      {
        algorithms[i][j].Repair();
      }
    }
  }
  
  public String[] GetAlgorithmsCollectionList()
  {
    return collectionNames;
  }
  
  public int NewAlgorithmsCollection(String name)
  {
    int pos=algorithms.length;
    Algorithm[][] newAlgorithms=new Algorithm[algorithms.length+1][];
    String[] newNames=new String[collectionNames.length+1];
    for (int i=0;i<algorithms.length;i++)
    {
      newAlgorithms[i]=algorithms[i];
      newNames[i]=collectionNames[i];
    }
    newNames[pos]=name;
    newAlgorithms[pos]=new Algorithm[0];
    algorithms=newAlgorithms;
    collectionNames=newNames;
    return pos;
  }
  
  public void RenameAlgorithmsCollection(int algorithmsCollectionIndex, String newName)
  {
    if ((algorithmsCollectionIndex>=0) && (algorithmsCollectionIndex<collectionNames.length))
    {
      collectionNames[algorithmsCollectionIndex]=newName;
    }
  }
  
  public void DeleteAlgorithmsCollection(int algorithmsCollectionIndex)
  {
    if (algorithms.length>0)
    {
      Algorithm[][] newAlgorithms=new Algorithm[algorithms.length-1][];
      String[] newNames=new String[collectionNames.length-1];
      int pos=0;
      for (int i=0;i<algorithms.length;i++)
      {
        if (i!=algorithmsCollectionIndex)
        {
          newAlgorithms[pos]=algorithms[i];
          newNames[pos]=collectionNames[i];
          pos++;
        }
      }
      algorithms=newAlgorithms;
      collectionNames=newNames;
    }
  }
  
  public int NewAlgorithm(int algorithmsCollectionIndex, String name)
  {
    int pos=-1;
    if ((algorithmsCollectionIndex>=0) && (algorithmsCollectionIndex<algorithms.length))
    {
      Algorithm[] newAlgorithms=new Algorithm[algorithms[algorithmsCollectionIndex].length+1];
      pos=algorithms[algorithmsCollectionIndex].length;
      for (int i=0;i<algorithms[algorithmsCollectionIndex].length;i++)
      {
        newAlgorithms[i]=algorithms[algorithmsCollectionIndex][i];
      }
      newAlgorithms[pos]=new Algorithm();
      newAlgorithms[pos].name=name;
      algorithms[algorithmsCollectionIndex]=newAlgorithms;
    }
    return pos;
  }
  
  public void RenameAlgorithm(int algorithmsCollectionIndex, int algorithmIndex, String newName)
  {
    if ((algorithmsCollectionIndex>=0) && (algorithmsCollectionIndex<algorithms.length))
    {
      if ((algorithmIndex>=0) && (algorithmIndex<algorithms[algorithmsCollectionIndex].length))
      {
        algorithms[algorithmsCollectionIndex][algorithmIndex].name=newName;
      }
    }
  }
  
  public void DeleteAlgorithm(int algorithmsCollectionIndex, int algorithmIndex)
  {
    if ((algorithmsCollectionIndex>=0) && (algorithmsCollectionIndex<algorithms.length))
    {
      if ((algorithmIndex>=0) && (algorithmIndex<algorithms[algorithmsCollectionIndex].length))
      {
        Algorithm[] newAlgorithms=new Algorithm[algorithms[algorithmsCollectionIndex].length-1];
        int pos=0;
        for (int i=0;i<algorithms[algorithmsCollectionIndex].length;i++)
        {
          if (i!=algorithmIndex)
          {
            newAlgorithms[pos]=algorithms[algorithmsCollectionIndex][i];
            pos++;
          }
        }
        algorithms[algorithmsCollectionIndex]=newAlgorithms;
      }
    }
  }
  
  public String[] GetAlgorithmList(int algorithmsCollectionIndex)
  {
    String[] res=new String[algorithms[algorithmsCollectionIndex].length];
    for (int i=0;i<algorithms[algorithmsCollectionIndex].length;i++)
    {
      res[i]=algorithms[algorithmsCollectionIndex][i].name;
    }
    return res;
  }
  
  public Algorithm GetAlgorithm(int algorithmsCollectionIndex,int algorithmIndex)
  {
    if ((algorithmsCollectionIndex>=0) && (algorithmsCollectionIndex<algorithms.length))
    {
      if ((algorithmIndex>=0) && (algorithmIndex<algorithms[algorithmsCollectionIndex].length))
      {
        return algorithms[algorithmsCollectionIndex][algorithmIndex];
      }
    }
    return null;
  }
  
}
