/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package algorithm;

import java.util.HashMap;
import java.util.Set;
import network.LinkMessage;
import network.Message;
import other.Functions;
import player.Player;
import thread.NodeThread;

/**
 *
 * @author Dur
 */
public class DistributedAlgorithm 
{
  private NodeThread nodeThread=null;
  private HashMap<Integer,MessageReceivedListener> listeners=new HashMap<Integer, MessageReceivedListener>();
  
  public DistributedAlgorithm()
  {
  }
  
  public void SetNodeThread(NodeThread nodeThread)
  {
    this.nodeThread=nodeThread;
  }
  
  protected void SendMessageByLink(int type, Object mes, int linkNum)
  {
    if (LinkExists(linkNum))
    {
      if (nodeThread.player.GetStatus()!=Player.STATUS_STARTED)
      {
        do
        {
          try
          {
            nodeThread.ReceiveObject();
          }
          catch (Exception e){}
        }
        while (nodeThread.player.GetStatus()!=Player.STATUS_STARTED);
      }
      Message mesSend=new Message(type, mes);
      nodeThread.player.linksThread.SendMessage(nodeThread.node, nodeThread.node.links[linkNum], mesSend); 
    }
  }
  
  protected void SendMessageToNode(int type, Object mes, int nodeId)
  {
    if (nodeThread.player.GetStatus()!=Player.STATUS_STARTED)
    {
      do
      {
        try
        {
          nodeThread.ReceiveObject();
        }
        catch (Exception e){}
      }
      while (nodeThread.player.GetStatus()!=Player.STATUS_STARTED);
    }
    Message mesSend=new Message(type, mes);
    nodeThread.player.linksThread.SendMessage(nodeThread.node, nodeThread.node.network.GetNodeById(nodeId), mesSend);
  }
  
  protected Message ReceiveMessage()
  {
    Message res=null;
    if (nodeThread.player.GetStatus()!=Player.STATUS_STARTED)
    {
      do
      {
        try
        {
          nodeThread.ReceiveObject();
        }
        catch (Exception e){}
      }
      while (nodeThread.player.GetStatus()!=Player.STATUS_STARTED);
    }
    //check new message
    do
    {
      LinkMessage newMes=nodeThread.player.linksThread.ReceiveMessage(nodeThread.node,listeners);
      if (newMes!=null)
      {
        res=newMes.message;
      }
      if (res==null)
      {
        try
        {
          nodeThread.ReceiveObject();
        }
        catch (Exception e){}
      }
    } while (res==null);
    return res;
  }
  
  protected Message ReceiveMessage(int linkNum)
  {
    Message res=null;
    if (nodeThread.player.GetStatus()!=Player.STATUS_STARTED)
    {
      do
      {
        try
        {
          nodeThread.ReceiveObject();
        }
        catch (Exception e){}
      }
      while (nodeThread.player.GetStatus()!=Player.STATUS_STARTED);
    }
    
    //check new message
    do
    {
      LinkMessage newMes=nodeThread.player.linksThread.ReceiveMessage(nodeThread.node, linkNum, listeners);
      if (newMes!=null)
      {
        res=newMes.message;
      }
      if (res==null)
      {
        try
        {
          nodeThread.ReceiveObject();
        }
        catch (Exception e){}
      }
    } while (res==null);
    return res;
  }
  
  protected Message ReceiveMessage(Set<Integer> linkSet)
  {
    Message res=null;
    if (nodeThread.player.GetStatus()!=Player.STATUS_STARTED)
    {
      do
      {
        try
        {
          nodeThread.ReceiveObject();
        }
        catch (Exception e){}
      }
      while (nodeThread.player.GetStatus()!=Player.STATUS_STARTED);
    }
    
    //check new message
    do
    {
      LinkMessage newMes=nodeThread.player.linksThread.ReceiveMessage(nodeThread.node, linkSet, listeners);
      if (newMes!=null)
      {
        res=newMes.message;
      }
      if (res==null)
      {
        try
        {
          nodeThread.ReceiveObject();
        }
        catch (Exception e){}
      }
    } while (res==null);
    return res;
  }
  
  protected int GetLinksCount()
  {
    return nodeThread.node.links.length;
  }
  
  protected boolean LinkExists(int linkNum)
  {
    return ((linkNum>=0) && (linkNum<nodeThread.node.links.length));
  }
  
  protected int GetNodesCount()
  {
    return nodeThread.node.network.nodes.length;
  }
  
  protected boolean NodeExists(int nodeId)
  {
    return (nodeThread.node.network.GetNodeById(nodeId)!=null);
  }
  
  protected int[] GetNodesIds()
  {
    int[] ids=new int[nodeThread.node.network.nodes.length];
    for (int i=0;i<nodeThread.node.network.nodes.length;i++)
    {
      ids[i]=Functions.intVal(nodeThread.node.network.nodes[i].prop.get("id").toString());
    }
    return ids;
  }
  
  protected void SetProperty(Object key, Object value)
  {
    if ((key!=null) && (!key.toString().equals("id")))
    {
      nodeThread.prop.put(key, value);
    }
  }
  
  protected Object GetProperty(Object key)
  {
    return nodeThread.prop.get(key);
  }
  
  protected void Assert(boolean cond, String text)
  {
    if (!cond)
      nodeThread.player.WriteAssert(text);
  }
  
  protected void SetMessageReceivedListener(int type, MessageReceivedListener listener)
  {
    if (listener!=null)
      listeners.put(type, listener);
  }
  
  protected int GetId()
  {
    return Functions.intVal(nodeThread.prop.get("id").toString());
  }
  
  public void Run()
  {
    
  }
  
  public void StopProcess()
  {
    throw new StopException();
  }
  
}
