/*
 * SourceCode.java
 *
 * Created on Utorok, 2008, aprl 1, 18:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm;

import java.io.File;
import java.io.Serializable;
import other.Configuration;
import other.FileClassLoader;
import other.Functions;
import other.Global;

/**
 *
 * @author Dur
 */
public class SourceCode implements Serializable
{
  
  protected String code="";
  protected transient FileClassLoader fileClassLoader=null;
  protected String compilationError="";
  
  /** Creates a new instance of SourceCode */
  public SourceCode() 
  {
    SetCode(GetEmptyAlgorithm());
  }
  
  public String GetCode()
  {
    return code;
  }
  
  public void SetCode(String code)
  {
    this.code=code;
  }
  
  public String GetSourceCodeClassName()
  {
    try
    {
      if (code!=null)
      {
        String s1="class";
        String s2="extends";
        int pos1=code.indexOf(s1);
        int pos2=code.indexOf(s2);
        if ((pos1>-1) && (pos2>-1) && ((pos1+s1.length())<=pos2))
        {
          String res=code.substring(pos1+s1.length(), pos2);
          return res.trim();
        }
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Error: algorithm->SourceCode->GetSourceCodeClassName", e);
    }
    return null;
  }
  
  protected void SaveSourceCode()
  {
    try
    {
      if (code!=null)
      {
        Functions.SaveToFile(code, new File(Configuration.temporaryDir+"/"+GetSourceCodeClassName()+".java"));
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Error: algorithm->SourceCode->SaveSourceCode", e);
    }
  }
  
  public boolean Compile()
  {
    try
    {
      compilationError="";
      try
      {
        Functions.DeleteDirectory(new File(Configuration.temporaryDir));
        new File(Configuration.temporaryDir).mkdirs();
      }
      catch (Exception e){}
      if (Configuration.canCompile)
      {
        String sourceCodeClassName=GetSourceCodeClassName();
        if (sourceCodeClassName!=null)
        {
          SaveSourceCode();
          try
          {
            new File(Configuration.temporaryDir+"/"+sourceCodeClassName+".class").delete();
          }
          catch (Exception e2){}
          Process p=Runtime.getRuntime().exec(new String[]{"\""+new File(Configuration.javaCompilerPath).getAbsolutePath()+"\"","\""+new File(Configuration.temporaryDir+"/"+sourceCodeClassName+".java").getAbsolutePath()+"\"","-classpath","\""+new File(Configuration.programPath).getAbsolutePath()+"\""});
          p.waitFor();
          compilationError=Functions.ReadStream(p.getErrorStream());
          FileClassLoader fcl=new FileClassLoader(new File(Configuration.temporaryDir+"/"+sourceCodeClassName+".class"), sourceCodeClassName);
          fileClassLoader=fcl;
          return fcl.IsFileOk();
        }
      }
      else
      {
        fileClassLoader=null;
        return true;
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Error: algorithm->SourceCode->Compile", e);
    }
    return false;
  }
  
  public String GetCompilationError()
  {
    return compilationError;
  }
  
  public DistributedAlgorithm GetDistributedAlgorithm() throws Exception
  {
    if (fileClassLoader!=null)
    {
      return (DistributedAlgorithm) fileClassLoader.GetNewInstance();
    }
    return new DistributedAlgorithm();
  }
  
  public static String GetEmptyAlgorithm()
  {
     String s=
      "import algorithm.DistributedAlgorithm;\r" +
      "import algorithm.MessageReceivedListener;\r" +
      "import network.Message;\r\r" +
      "public class MyAlgorithm extends DistributedAlgorithm\r" +
      "{\r  \r" +
      "  public void Run()\r" +
      "  {\r" +
      "    \r" +
      "  }\r  \r" +
      "}";
     return s;
  }
  
}
