/*
 * ChooseAlgorithmsCollectionForm.java
 *
 * Created on Pondelok, 2008, marec 31, 19:41
 */

package form;

import algorithm.Algorithm;
import java.awt.Point;
import java.util.Enumeration;
import javax.swing.JOptionPane;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import other.CollectionTreeCellRenderer;
import other.Configuration;
import other.Global;

/**
 *
 * @author  Dur
 */
public class ChooseAlgorithmsCollectionForm extends javax.swing.JFrame {
  
  private void InitAlgorithmsCollection()
  {
    getRootPane().setDefaultButton(jButton1);
    jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    jTree1.addTreeSelectionListener(new TreeSelectionListener() 
    {
      public void valueChanged(TreeSelectionEvent e) {
        boolean b=((jTree1.getSelectionPath()!=null) && (jTree1.getSelectionPath().getPath().length>=2));
        jButton4.setEnabled(b);
        jButton5.setEnabled(b);
        if (b)
        {
          jButton1.setEnabled(jTree1.getSelectionPath().getPath().length==3);
        }
      }
    });
    jTree1.setCellRenderer(new CollectionTreeCellRenderer());
  }
  
  private void expandAll(JTree tree, boolean expand) {
      TreeNode root = (TreeNode)tree.getModel().getRoot();

      // Traverse tree from root
      expandAll(tree, new TreePath(root), expand);
  }
  private void expandAll(JTree tree, TreePath parent, boolean expand) {
      // Traverse children
      TreeNode node = (TreeNode)parent.getLastPathComponent();
      if (node.getChildCount() >= 0) {
          for (Enumeration e=node.children(); e.hasMoreElements(); ) {
              TreeNode n = (TreeNode)e.nextElement();
              TreePath path = parent.pathByAddingChild(n);
              expandAll(tree, path, expand);
          }
      }

      // Expansion or collapse must be done bottom-up
      if (expand) {
          tree.expandPath(parent);
      } else {
          tree.collapsePath(parent);
      }
  }
  
  private void SelectPosition(int x)
  {
    Object[] o=new Object[2];
    o[0]=jTree1.getModel().getRoot();
    Object node=o[0];
    o[1]=jTree1.getModel().getChild(node, x);
    jTree1.setSelectionPath(new TreePath(o));
  }

  private void SelectPosition(int x, int y)
  {
    Object[] o=new Object[3];
    o[0]=jTree1.getModel().getRoot();
    Object node=o[0];
    o[1]=jTree1.getModel().getChild(node, x);
    node=o[1];
    o[2]=jTree1.getModel().getChild(node, y);
    jTree1.setSelectionPath(new TreePath(o));
  }
    
  public void UpdateForm()
  {
    try
    {
      DefaultMutableTreeNode root=new DefaultMutableTreeNode("Algorithm collections");
      String[] cols=Global.algorithmsCollection.GetAlgorithmsCollectionList();
      for (int i=0;i<cols.length;i++)
      {
        String[] algs=Global.algorithmsCollection.GetAlgorithmList(i);
        DefaultMutableTreeNode colNode=new DefaultMutableTreeNode(cols[i]);
        for (int j=0;j<algs.length;j++)
        {
          DefaultMutableTreeNode algNode=new DefaultMutableTreeNode(algs[j]);
          colNode.add(algNode);
        }
        root.add(colNode);
      }
      jTree1.setModel(new DefaultTreeModel(root));
      expandAll(jTree1, true);
    }
    catch (Exception e)
    {
      Global.errorLog.Write("ChooseAlgorithmsCollectionForm->UpdateForm: ", e);
    }
  }
  
  private Point GetAlgorithmPosition()
  {
    Point p=new Point();
    TreeModel model=jTree1.getModel();
    Object root=model.getRoot();
    Object selObject=jTree1.getSelectionPath().getPath()[jTree1.getSelectionPath().getPath().length-1];
    int n=model.getChildCount(model.getRoot());
    for (int i=0;i<n;i++)
    {
      int index=model.getIndexOfChild(model.getChild(root, i), selObject);
      if (index!=-1)
      {
        p.x=i;
        p.y=index;
      }
    }
    return p;
  }
  
  private int GetCollectionPosition()
  {
    TreeModel model=jTree1.getModel();
    Object selObject=jTree1.getSelectionPath().getPath()[jTree1.getSelectionPath().getPath().length-1];
    return model.getIndexOfChild(model.getRoot(), selObject);
  }
  
  /** Creates new form ChooseAlgorithmsCollectionForm */
  public ChooseAlgorithmsCollectionForm() {
    initComponents();
    InitAlgorithmsCollection();
    UpdateForm();
  }
  
  public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
      public void run() {
        new ChooseAlgorithmsCollectionForm().setVisible(true);
      }
    });
  }

  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPanel1 = new javax.swing.JPanel();
    jButton1 = new javax.swing.JButton();
    jButton2 = new javax.swing.JButton();
    jPanel5 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    jScrollPane1 = new javax.swing.JScrollPane();
    jTree1 = new javax.swing.JTree();
    jPanel6 = new javax.swing.JPanel();
    jButton3 = new javax.swing.JButton();
    jButton4 = new javax.swing.JButton();
    jButton5 = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setTitle("VDA");
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
    });

    jButton1.setText("Select");
    jButton1.setEnabled(false);
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton1);

    jButton2.setText("Exit");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton2);

    getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);
    getContentPane().add(jPanel5, java.awt.BorderLayout.LINE_END);
    getContentPane().add(jPanel4, java.awt.BorderLayout.WEST);
    getContentPane().add(jPanel3, java.awt.BorderLayout.PAGE_START);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        jTree1MouseClicked(evt);
      }
    });
    jScrollPane1.setViewportView(jTree1);

    jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);

    jButton3.setText("New");
    jButton3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton3ActionPerformed(evt);
      }
    });
    jPanel6.add(jButton3);

    jButton4.setText("Rename");
    jButton4.setEnabled(false);
    jButton4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton4ActionPerformed(evt);
      }
    });
    jPanel6.add(jButton4);

    jButton5.setText("Delete");
    jButton5.setEnabled(false);
    jButton5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton5ActionPerformed(evt);
      }
    });
    jPanel6.add(jButton5);

    jPanel2.add(jPanel6, java.awt.BorderLayout.PAGE_END);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-548)/2, (screenSize.height-327)/2, 548, 327);
  }// </editor-fold>//GEN-END:initComponents

  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    Point p=GetAlgorithmPosition();
    Algorithm alg=Global.algorithmsCollection.GetAlgorithm(p.x, p.y);
    if (alg!=null)
    {
      setVisible(false);
      alg.OpenPropertiesForm(this);
    }
  }//GEN-LAST:event_jButton1ActionPerformed

  private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    formWindowClosing(null);
  }//GEN-LAST:event_jButton2ActionPerformed

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
  if (!Configuration.readonly)
  {
    Global.algorithmsCollection.Save();
  }
  System.exit(0);
}//GEN-LAST:event_formWindowClosing

private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
  if ((jTree1.getSelectionPath()!=null) && (jTree1.getSelectionPath().getPath().length>=2))
  {
    //algorithm should be added
    int colIndex=0;
    if (jTree1.getSelectionPath().getPath().length==2)
      colIndex=GetCollectionPosition();
    else
      colIndex=GetAlgorithmPosition().x;
    String name=null;
    if ((name=JOptionPane.showInputDialog("Enter algorithm's name", "name"))!=null)
    {
      int index=Global.algorithmsCollection.NewAlgorithm(colIndex, name);
      UpdateForm();
      SelectPosition(colIndex, index);
    }
  }
  else
  {
    //collection should be added
    String name=null;
    if ((name=JOptionPane.showInputDialog("Enter algorithmCollection name", "name"))!=null)
    {
      int index=Global.algorithmsCollection.NewAlgorithmsCollection(name);
      UpdateForm();
      SelectPosition(index);
    }
  }
}//GEN-LAST:event_jButton3ActionPerformed

private void jTree1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseClicked
  if ((evt!=null) && (evt.getClickCount()>1) && (jButton1.isEnabled()))
  {
    jButton1ActionPerformed(null);
  }
}//GEN-LAST:event_jTree1MouseClicked

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
  if (jTree1.getSelectionPath().getPath().length>=3)
  {
    //rename algorithm
    Point p=GetAlgorithmPosition();
    String name=null;
    String oldName=Global.algorithmsCollection.GetAlgorithm(p.x, p.y).name;
    if ((name=JOptionPane.showInputDialog("Enter algorithm's name", oldName))!=null)
    {
      Global.algorithmsCollection.RenameAlgorithm(p.x, p.y, name);
      UpdateForm();
      SelectPosition(p.x, p.y);
    }
  }
  else
  {
    //rename collection
    int index=GetCollectionPosition();
    String name=null;
    String oldName=Global.algorithmsCollection.GetAlgorithmsCollectionList()[index];
    if ((name=JOptionPane.showInputDialog("Enter algorithm collection name", oldName))!=null)
    {
      Global.algorithmsCollection.RenameAlgorithmsCollection(index, name);
      UpdateForm();
      SelectPosition(index);
    }
  }
}//GEN-LAST:event_jButton4ActionPerformed

private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
  if (jTree1.getSelectionPath().getPath().length>=3)
  {
    //delete algorithm
    Point p=GetAlgorithmPosition();
    if (JOptionPane.showConfirmDialog(this, "Do you really want to delete selected algorithm?", "Delete", JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION)
    {
      Global.algorithmsCollection.DeleteAlgorithm(p.x, p.y);
      UpdateForm();
      jButton1.setEnabled(false);
    }
  }
  else
  {
    //delete collection
    if (JOptionPane.showConfirmDialog(this, "Do you really want to delete selected algorithm collection?", "Delete", JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION)
    {
      Global.algorithmsCollection.DeleteAlgorithmsCollection(GetCollectionPosition());
      UpdateForm();
    }
  }
}//GEN-LAST:event_jButton5ActionPerformed
  
  /**
   * @param args the command line arguments
   */
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.JButton jButton1;
  public javax.swing.JButton jButton2;
  public javax.swing.JButton jButton3;
  public javax.swing.JButton jButton4;
  public javax.swing.JButton jButton5;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JPanel jPanel3;
  public javax.swing.JPanel jPanel4;
  public javax.swing.JPanel jPanel5;
  public javax.swing.JPanel jPanel6;
  public javax.swing.JScrollPane jScrollPane1;
  public javax.swing.JTree jTree1;
  // End of variables declaration//GEN-END:variables
  
}
