/*
 * NetworkEditorForm.java
 *
 * Created on Pondelok, 2008, aprl 14, 16:57
 */

package form;

import form.dialog.LinksSpeedDialog;
import form.dialog.SlidersDialog;
import graphics.Layout;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import network.Link;
import network.Node;
import java.awt.Point;
import javax.swing.JFrame;
import javax.swing.JPanel;
import network.Network;
import java.awt.Graphics;
import java.util.Random;
import other.AssociativeArray;
import other.IDialog;

/**
 *
 * @author  Dur
 */
public class NetworkEditorForm extends javax.swing.JFrame {
  protected Network network;
  protected JFrame caller;
  protected Point pressedPoint=null;
  protected Node pressedNode=null,selectedNode=null;
  protected Link pressedLink=null,selectedLink=null;
  protected java.awt.event.MouseEvent evt=null;
  protected boolean mouseDragging=false;
  
  private void InitForm()
  {
    setExtendedState(this.MAXIMIZED_BOTH);
  }
  
  /** Creates new form NetworkEditorForm */
  public NetworkEditorForm(JFrame caller,Network network) {
    this.caller=caller;
    this.network=network;
    initComponents();
    InitForm();
  }
  
  private void RefreshNetwork()
  {
    jPanel1.paintImmediately(0,0,jPanel1.getWidth(),jPanel1.getHeight());
    try{Thread.sleep(10);}catch(Exception e){}
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPopupMenu1 = new javax.swing.JPopupMenu();
    jMenuItem15 = new javax.swing.JMenuItem();
    jMenuItem16 = new javax.swing.JMenuItem();
    jPanel1 = new JPanel(){
      public void paintComponent(Graphics g){
        super.paintComponent(g);
        network.GetAlgorithm().GetVisualization().DrawStaticNetwork(network,g);
        if ((evt!=null) && (evt.getModifiersEx()==evt.BUTTON1_DOWN_MASK) && (pressedNode!=null))
        {
          Node node=new Node(network);
          node.SetPosition(evt.getPoint());
          Link link=new Link(pressedNode,node);
          network.GetAlgorithm().GetVisualization().DrawStaticLink(link);
        }
        if (selectedNode!=null)
        {
          network.GetAlgorithm().GetVisualization().DrawStaticSelectedNode(selectedNode);
          //g.fillOval(selectedNode.position.x-selectedNode.dimension.x/2, selectedNode.position.y-selectedNode.dimension.y/2, selectedNode.dimension.x, selectedNode.dimension.y);
        }
        else if (selectedLink!=null)
        {
          network.GetAlgorithm().GetVisualization().DrawStaticSelectedLink(selectedLink);
        }

        jLabel1.setText("Nodes: "+Integer.toString(network.nodes.length));
        jLabel2.setText("Links: "+Integer.toString(network.links.length));
      }
    };
    jPanel2 = new javax.swing.JPanel();
    jLabel1 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();
    jMenuBar1 = new javax.swing.JMenuBar();
    jMenu5 = new javax.swing.JMenu();
    jMenuItem25 = new javax.swing.JMenuItem();
    jMenuItem26 = new javax.swing.JMenuItem();
    jMenuItem27 = new javax.swing.JMenuItem();
    jMenu1 = new javax.swing.JMenu();
    jMenuItem17 = new javax.swing.JMenuItem();
    jSeparator1 = new javax.swing.JSeparator();
    jMenu2 = new javax.swing.JMenu();
    jMenuItem1 = new javax.swing.JMenuItem();
    jMenuItem3 = new javax.swing.JMenuItem();
    jMenuItem4 = new javax.swing.JMenuItem();
    jMenuItem5 = new javax.swing.JMenuItem();
    jMenuItem6 = new javax.swing.JMenuItem();
    jMenuItem7 = new javax.swing.JMenuItem();
    jMenuItem23 = new javax.swing.JMenuItem();
    jMenu3 = new javax.swing.JMenu();
    jMenuItem21 = new javax.swing.JMenuItem();
    jMenuItem20 = new javax.swing.JMenuItem();
    jMenu4 = new javax.swing.JMenu();
    jMenuItem10 = new javax.swing.JMenuItem();
    jMenuItem12 = new javax.swing.JMenuItem();
    jMenuItem14 = new javax.swing.JMenuItem();
    jSeparator2 = new javax.swing.JSeparator();
    jMenuItem19 = new javax.swing.JMenuItem();
    jMenuItem18 = new javax.swing.JMenuItem();
    jMenuItem22 = new javax.swing.JMenuItem();

    jPopupMenu1.setInvoker(jPanel1);
    jPopupMenu1.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
      public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
      }
      public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
        jPopupMenu1PopupMenuWillBecomeInvisible(evt);
      }
      public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
      }
    });

    jMenuItem15.setText("Properties");
    jMenuItem15.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem15ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem15);

    jMenuItem16.setText("Delete");
    jMenuItem16.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem16ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem16);

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("VDA");
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
      public void windowOpened(java.awt.event.WindowEvent evt) {
        formWindowOpened(evt);
      }
    });

    jPanel1.setBackground(new java.awt.Color(255, 255, 255));
    jPanel1.setDebugGraphicsOptions(javax.swing.DebugGraphics.NONE_OPTION);
    jPanel1.setFont(new java.awt.Font("Courier New", 0, 11));
    jPanel1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
      public void mouseDragged(java.awt.event.MouseEvent evt) {
        jPanel1MouseDragged(evt);
      }
    });
    jPanel1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(java.awt.event.MouseEvent evt) {
        jPanel1MousePressed(evt);
      }
      public void mouseReleased(java.awt.event.MouseEvent evt) {
        jPanel1MouseReleased(evt);
      }
    });
    jPanel1.setLayout(new java.awt.BorderLayout());
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

    jLabel1.setText("Nodes: 0");
    jPanel2.add(jLabel1);

    jLabel3.setText("  ");
    jPanel2.add(jLabel3);

    jLabel2.setText("Links: 0");
    jPanel2.add(jLabel2);

    getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

    jMenu5.setText("Network");

    jMenuItem25.setText("Nodes properties");
    jMenuItem25.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem25ActionPerformed(evt);
      }
    });
    jMenu5.add(jMenuItem25);

    jMenuItem26.setText("Links properties");
    jMenuItem26.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem26ActionPerformed(evt);
      }
    });
    jMenu5.add(jMenuItem26);

    jMenuItem27.setText("Links speed");
    jMenuItem27.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem27ActionPerformed(evt);
      }
    });
    jMenu5.add(jMenuItem27);

    jMenuBar1.add(jMenu5);

    jMenu1.setText("Graph");

    jMenuItem17.setText("Clear");
    jMenuItem17.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem17ActionPerformed(evt);
      }
    });
    jMenu1.add(jMenuItem17);
    jMenu1.add(jSeparator1);

    jMenu2.setText("Create");

    jMenuItem1.setText("Random graph");
    jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem1ActionPerformed(evt);
      }
    });
    jMenu2.add(jMenuItem1);

    jMenuItem3.setText("Complete graph");
    jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem3ActionPerformed(evt);
      }
    });
    jMenu2.add(jMenuItem3);

    jMenuItem4.setText("Bipartite graph");
    jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem4ActionPerformed(evt);
      }
    });
    jMenu2.add(jMenuItem4);

    jMenuItem5.setText("Complete bipartite graph");
    jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem5ActionPerformed(evt);
      }
    });
    jMenu2.add(jMenuItem5);

    jMenuItem6.setText("Cyclic graph");
    jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem6ActionPerformed(evt);
      }
    });
    jMenu2.add(jMenuItem6);

    jMenuItem7.setText("Tree graph");
    jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem7ActionPerformed(evt);
      }
    });
    jMenu2.add(jMenuItem7);

    jMenuItem23.setText("Grid graph");
    jMenuItem23.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem23ActionPerformed(evt);
      }
    });
    jMenu2.add(jMenuItem23);

    jMenu1.add(jMenu2);

    jMenu3.setText("Test");

    jMenuItem21.setText("Complete");
    jMenuItem21.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem21ActionPerformed(evt);
      }
    });
    jMenu3.add(jMenuItem21);

    jMenuItem20.setText("Bipartite");
    jMenuItem20.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem20ActionPerformed(evt);
      }
    });
    jMenu3.add(jMenuItem20);

    jMenu1.add(jMenu3);

    jMenuBar1.add(jMenu1);

    jMenu4.setText("Layout");

    jMenuItem10.setText("Random");
    jMenuItem10.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem10ActionPerformed(evt);
      }
    });
    jMenu4.add(jMenuItem10);

    jMenuItem12.setText("Cyclic");
    jMenuItem12.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem12ActionPerformed(evt);
      }
    });
    jMenu4.add(jMenuItem12);

    jMenuItem14.setText("Bipartite");
    jMenuItem14.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem14ActionPerformed(evt);
      }
    });
    jMenu4.add(jMenuItem14);
    jMenu4.add(jSeparator2);

    jMenuItem19.setText("Center");
    jMenuItem19.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem19ActionPerformed(evt);
      }
    });
    jMenu4.add(jMenuItem19);

    jMenuItem18.setText("Stretch to window");
    jMenuItem18.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem18ActionPerformed(evt);
      }
    });
    jMenu4.add(jMenuItem18);

    jMenuItem22.setText("Snap to grid");
    jMenuItem22.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem22ActionPerformed(evt);
      }
    });
    jMenu4.add(jMenuItem22);

    jMenuBar1.add(jMenu4);

    setJMenuBar(jMenuBar1);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-400)/2, (screenSize.height-298)/2, 400, 298);
  }// </editor-fold>//GEN-END:initComponents

  private void jMenuItem15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem15ActionPerformed
    if (selectedNode!=null)
    {
      IDialog dialog=selectedNode.CreatePropertiesDialog(this,true);
      dialog.setVisible(true);
    }
    else if (selectedLink!=null)
    {
      IDialog dialog=selectedLink.CreatePropertiesDialog(this,true);
      dialog.setVisible(true);
    }
    selectedLink=null;
    selectedNode=null;
    jPopupMenu1PopupMenuWillBecomeInvisible(null);
  }//GEN-LAST:event_jMenuItem15ActionPerformed

  private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
    //load nodes dimension
    Point p=network.GetAlgorithm().GetActivatedVisualizationData().GetNodeDimension();
    for (int i=0;i<network.nodes.length;i++)
    {
      network.nodes[i].dimension=p;
    }
    
    //check whether is whole graph visible
    if (!network.IsWholeGraphVisible(jPanel1.getSize()))
    {
      if (JOptionPane.showConfirmDialog(this,"Some node is out of clipping area."+System.getProperty("line.separator")+"Would you like to stretch the graph to window?","Delete",JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION)
      {
        Layout.StretchToWindowLayout(network,jPanel1.getSize());
        jPanel1.repaint();
      }
    }
  }//GEN-LAST:event_formWindowOpened

  private void jMenuItem22ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem22ActionPerformed
    SlidersDialog dialog=new SlidersDialog(this,true);
    dialog.SetSliderCount(1);
    dialog.SetSlider(0,"Dist",10);
    dialog.setTitle("Snap to grid");
    dialog.setVisible(true);
    if (dialog.IsOkClicked())
    {
      Layout.SnapToGridLayout(network,jPanel1.getSize(),dialog.GetValue(0));
    }
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem22ActionPerformed

  private void jMenuItem23ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem23ActionPerformed
    SlidersDialog dialog=new SlidersDialog(this,true);
    dialog.SetSliderCount(2);
    dialog.SetSlider(0,"Width",5,15);
    dialog.SetSlider(1,"Height",5,15);
    dialog.setTitle("Create grid graph");
    dialog.setVisible(true);
    if (dialog.IsOkClicked())
    {
      network.CreateGridGraph(dialog.GetValue(0),dialog.GetValue(1),jPanel1.getSize());
    }
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem23ActionPerformed

  private void jMenuItem21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem21ActionPerformed
    if (network.TestComplete())
      JOptionPane.showMessageDialog(this,"Graph is complete.");
    else
      JOptionPane.showMessageDialog(this,"Graph is not complete.");
  }//GEN-LAST:event_jMenuItem21ActionPerformed

  private void jMenuItem20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem20ActionPerformed
    if (network.TestBipartite())
      JOptionPane.showMessageDialog(this,"Graph is bipartite.");
    else
      JOptionPane.showMessageDialog(this,"Graph is not bipartite.");
  }//GEN-LAST:event_jMenuItem20ActionPerformed

  private void jMenuItem14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem14ActionPerformed
    if (network.TestBipartite())
      Layout.BipartiteLayout(network,jPanel1.getSize());
    else
      JOptionPane.showMessageDialog(this,"Graph is not bipartite, thus layout can not be applied.");
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem14ActionPerformed

  private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
    SlidersDialog dialog=new SlidersDialog(this,true);
    dialog.SetSliderCount(2);
    dialog.SetSlider(0,"Nodes",8);
    dialog.SetSlider(1,"Nodes",8);
    dialog.setTitle("Create complete bipartite graph");
    dialog.setVisible(true);
    if (dialog.IsOkClicked())
    {
      network.CreateCompleteBipartiteGraph(dialog.GetValue(0),dialog.GetValue(1),jPanel1.getSize());
    }
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem5ActionPerformed

  private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
    SlidersDialog dialog=new SlidersDialog(this,true);
    dialog.SetSliderCount(3);
    dialog.SetSlider(0,"Nodes",8);
    dialog.SetSlider(1,"Nodes",8);
    dialog.SetSlider(2,"Links",15);
    dialog.setTitle("Create bipartite graph");
    dialog.setVisible(true);
    if (dialog.IsOkClicked())
    {
      network.CreateBipartiteGraph(dialog.GetValue(0),dialog.GetValue(1),dialog.GetValue(2),jPanel1.getSize());
    }
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem4ActionPerformed

  private void jMenuItem19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem19ActionPerformed
    Layout.CenterLayout(network,jPanel1.getSize());
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem19ActionPerformed

  private void jMenuItem18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem18ActionPerformed
    Layout.StretchToWindowLayout(network,jPanel1.getSize());
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem18ActionPerformed

  private void jMenuItem12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem12ActionPerformed
    Layout.CyclicLayout(network,jPanel1.getSize());
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem12ActionPerformed

  private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
    SlidersDialog dialog=new SlidersDialog(this,true);
    dialog.SetSliderCount(1);
    dialog.SetSlider(0,"Nodes",10);
    dialog.setTitle("Create cyclic graph");
    dialog.setVisible(true);
    if (dialog.IsOkClicked())
    {
      network.CreateCyclicGraph(dialog.GetValue(0),jPanel1.getSize());
    }
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem6ActionPerformed

  private void jMenuItem10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem10ActionPerformed
    Layout.RandomLayout(network,jPanel1.getSize());
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem10ActionPerformed

  private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
    SlidersDialog dialog=new SlidersDialog(this,true);
    dialog.SetSliderCount(1);
    dialog.SetSlider(0,"Nodes",10);
    dialog.setTitle("Create complete graph");
    dialog.setVisible(true);
    if (dialog.IsOkClicked())
    {
      network.CreateCompleteGraph(dialog.GetValue(0),jPanel1.getSize());
    }
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem3ActionPerformed

  private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
    SlidersDialog dialog=new SlidersDialog(this,true);
    dialog.SetSliderCount(2);
    dialog.SetSlider(0,"Nodes",10);
    dialog.SetSlider(1,"Links",15);
    dialog.setTitle("Create random graph");
    dialog.setVisible(true);
    if (dialog.IsOkClicked())
    {
      network.CreateRandomGraph(dialog.GetValue(0),dialog.GetValue(1),jPanel1.getSize());
    }
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem1ActionPerformed

  private void jMenuItem17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem17ActionPerformed
    network.Clear();
    jPanel1.repaint();
  }//GEN-LAST:event_jMenuItem17ActionPerformed

  private void jPopupMenu1PopupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_jPopupMenu1PopupMenuWillBecomeInvisible
    jPanel1.repaint();
  }//GEN-LAST:event_jPopupMenu1PopupMenuWillBecomeInvisible

  private void jMenuItem16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem16ActionPerformed
    if (selectedNode!=null)
    {
      network.DeleteNode(selectedNode);
    }
    else if (selectedLink!=null)
    {
      network.DeleteLink(selectedLink);
    }
    selectedLink=null;
    selectedNode=null;
    jPopupMenu1PopupMenuWillBecomeInvisible(null);
  }//GEN-LAST:event_jMenuItem16ActionPerformed

  private void jPanel1MouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MouseDragged
    if (evt.getModifiersEx()==evt.BUTTON1_DOWN_MASK)
    {
      if (pressedNode!=null)
      {
        this.evt=evt;
        RefreshNetwork();
      }
    }
    else if (evt.getModifiersEx()==evt.BUTTON3_DOWN_MASK)
    {
      if (pressedNode!=null)
      {
        pressedNode.SetPosition(evt.getPoint());
        RefreshNetwork();
      }
      else
      {
        //move all nodes
        for (int i=0;i<network.nodes.length;i++)
        {
          network.nodes[i].SetPosition(new Point(network.nodes[i].position.x+(evt.getX()-pressedPoint.x),network.nodes[i].position.y+(evt.getY()-pressedPoint.y)));          
        }
        pressedPoint=evt.getPoint();
        RefreshNetwork();
      }
    }
    mouseDragging=true;
  }//GEN-LAST:event_jPanel1MouseDragged

  private void jPanel1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MouseReleased
    selectedLink=null;
    selectedNode=null;
    if (evt.getButton()==evt.BUTTON1)
    {
      if (pressedNode==null)
      {
        //create new node
        network.AddNode().SetPosition(evt.getPoint());
      }
      else
      {
        //create new link
        Node releasedNode=network.GetNodeAtPosition(evt.getPoint());
        if ((releasedNode!=null) && (releasedNode!=pressedNode))
        {
          network.AddLink(pressedNode,releasedNode);
        }
      }
    }
    else if (evt.getButton()==evt.BUTTON3)
    {
      if (pressedNode!=null)
      {
        Node releasedNode=network.GetNodeAtPosition(evt.getPoint());
        if ((releasedNode==pressedNode) && (evt.isPopupTrigger()) && (!mouseDragging))
        {
          //popup menu on node
          selectedLink=null;
          selectedNode=pressedNode;
          Point p=evt.getPoint();
          p.x+=getX();
          p.y+=getY();
          jPopupMenu1.setLocation(p);
          jPopupMenu1.setVisible(true);
        }
      }
      else if (pressedLink!=null)
      {
        Link releasedLink=network.GetLinkAtPosition(evt.getPoint());
        if ((releasedLink==pressedLink) && (evt.isPopupTrigger()) && (!mouseDragging))
        {
          //popup menu on link
          selectedNode=null;
          selectedLink=pressedLink;
          Point p=evt.getPoint();
          p.x+=getX();
          p.y+=getY();
          jPopupMenu1.setLocation(p);
          jPopupMenu1.setVisible(true);
        }
      }
    }
    pressedNode=null;
    pressedLink=null;
    pressedPoint=null;
    this.evt=null;
    mouseDragging=false;
    RefreshNetwork();
  }//GEN-LAST:event_jPanel1MouseReleased

  private void jPanel1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MousePressed
    pressedPoint=evt.getPoint();
    pressedNode=network.GetNodeAtPosition(pressedPoint);
    pressedLink=network.GetLinkAtPosition(pressedPoint);
    this.evt=evt;
  }//GEN-LAST:event_jPanel1MousePressed

  private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
    if (caller!=null)
    {
      caller.setVisible(true);
    }
    dispose();
  }//GEN-LAST:event_formWindowClosing

private void jMenuItem26ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem26ActionPerformed
  Link link=network.CreateLink(null, null);
  IDialog dialog=link.CreatePropertiesDialog(this, true);
  dialog.setVisible(true);
  if (dialog.IsOKPressed())
  {
    for (int i=0;i<network.links.length;i++)
    {
      network.links[i].prop=(AssociativeArray<Object, Object>)link.prop.clone();
      network.links[i].constraints=link.constraints.clone();
    }
  }
  jPanel1.repaint();
}//GEN-LAST:event_jMenuItem26ActionPerformed

private void jMenuItem25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem25ActionPerformed
  Node node=network.CreateNode();
  IDialog dialog=node.CreatePropertiesDialog(this, true);
  dialog.setVisible(true);
  if (dialog.IsOKPressed())
  {
    for (int i=0;i<network.nodes.length;i++)
    {
      AssociativeArray<Object, Object> oldProp=network.nodes[i].prop;
      network.nodes[i].prop=(AssociativeArray<Object, Object>)node.prop.clone();
      network.nodes[i].prop.put("id", oldProp.get("id"));
    }
  }
  jPanel1.repaint();
}//GEN-LAST:event_jMenuItem25ActionPerformed

private void jMenuItem27ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem27ActionPerformed
  LinksSpeedDialog dial=new LinksSpeedDialog(this, true);
  dial.setVisible(true);
  AssociativeArray<String, Integer> object=dial.GetData();
  if (object!=null)
  {
    int min=object.get("minTransferSpeed");
    int max=object.get("maxTransferSpeed");
    Random rnd=new Random();
    for (int i=0;i<network.links.length;i++)
    {
      network.links[i].prop.put("transferSpeed", rnd.nextInt(max-min+1)+min);
    }
  }
}//GEN-LAST:event_jMenuItem27ActionPerformed

private void jMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem7ActionPerformed
  SlidersDialog dialog=new SlidersDialog(this,true);
  dialog.SetSliderCount(2);
  dialog.SetSlider(0,"Nodes",35);
  dialog.SetSlider(1,"Depth",6);
  dialog.setTitle("Create tree graph");
  dialog.setVisible(true);
  if (dialog.IsOkClicked())
  {
    network.CreateTreeGraph(dialog.GetValue(0), dialog.GetValue(1), jPanel1.getSize());
  }
  jPanel1.repaint();
}//GEN-LAST:event_jMenuItem7ActionPerformed
  
  /**
   * @param args the command line arguments
   */
 
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.JLabel jLabel1;
  public javax.swing.JLabel jLabel2;
  public javax.swing.JLabel jLabel3;
  public javax.swing.JMenu jMenu1;
  public javax.swing.JMenu jMenu2;
  public javax.swing.JMenu jMenu3;
  public javax.swing.JMenu jMenu4;
  public javax.swing.JMenu jMenu5;
  public javax.swing.JMenuBar jMenuBar1;
  public javax.swing.JMenuItem jMenuItem1;
  public javax.swing.JMenuItem jMenuItem10;
  public javax.swing.JMenuItem jMenuItem12;
  public javax.swing.JMenuItem jMenuItem14;
  public javax.swing.JMenuItem jMenuItem15;
  public javax.swing.JMenuItem jMenuItem16;
  public javax.swing.JMenuItem jMenuItem17;
  public javax.swing.JMenuItem jMenuItem18;
  public javax.swing.JMenuItem jMenuItem19;
  public javax.swing.JMenuItem jMenuItem20;
  public javax.swing.JMenuItem jMenuItem21;
  public javax.swing.JMenuItem jMenuItem22;
  public javax.swing.JMenuItem jMenuItem23;
  public javax.swing.JMenuItem jMenuItem25;
  public javax.swing.JMenuItem jMenuItem26;
  public javax.swing.JMenuItem jMenuItem27;
  public javax.swing.JMenuItem jMenuItem3;
  public javax.swing.JMenuItem jMenuItem4;
  public javax.swing.JMenuItem jMenuItem5;
  public javax.swing.JMenuItem jMenuItem6;
  public javax.swing.JMenuItem jMenuItem7;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JPopupMenu jPopupMenu1;
  public javax.swing.JSeparator jSeparator1;
  public javax.swing.JSeparator jSeparator2;
  // End of variables declaration//GEN-END:variables
  
}
