/*
 * VisualizationForm.java
 *
 * Created on Streda, 2008, mj 7, 22:58
 */

package form;

import form.dialog.LinkDialog;
import form.dialog.LinkInfoDialog;
import form.dialog.MessageInfoDialog;
import form.dialog.NodeDialog;
import form.dialog.NodeInfoDialog;
import form.dialog.StatisticsDialog;
import form.dialog.TextDialog;
import java.awt.Color;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseEvent;
import network.Link;
import network.LinkMessage;
import network.Network;
import network.Node;
import player.Player;

/**
 *
 * @author  Dur
 */
public class VisualizationForm extends javax.swing.JFrame {
  protected Network network;
  protected JFrame caller;
  protected Player player;
  protected Node selNode=null;
  protected Link selLink=null;
  protected LinkMessage selMes=null;
  
  /** Creates new form VisualizationForm */
  public VisualizationForm(JFrame caller, Network network) {
    initComponents();
    setExtendedState(this.MAXIMIZED_BOTH);
    this.network=network;
    this.caller=caller;
    player=new Player(network,jPanel5);
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPopupMenu1 = new javax.swing.JPopupMenu();
    jMenuItem1 = new javax.swing.JMenuItem();
    jMenuItem4 = new javax.swing.JMenuItem();
    jPopupMenu2 = new javax.swing.JPopupMenu();
    jMenuItem2 = new javax.swing.JMenuItem();
    jMenuItem5 = new javax.swing.JMenuItem();
    jPopupMenu3 = new javax.swing.JPopupMenu();
    jMenuItem3 = new javax.swing.JMenuItem();
    jPanel1 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    jLabel7 = new javax.swing.JLabel();
    jLabel6 = new javax.swing.JLabel();
    jLabel5 = new javax.swing.JLabel();
    jLabel1 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();
    jLabel4 = new javax.swing.JLabel();
    jPanel5 = new JPanel(){
      public void paintComponent(Graphics g){
        super.paintComponent(g);
        network.GetAlgorithm().GetVisualization().DrawNetwork(player,g);
        if (selNode!=null)
        {
          player.network.GetAlgorithm().GetVisualization().DrawSelectedNode(player, selNode);
        }
        if (selLink!=null)
        {
          player.network.GetAlgorithm().GetVisualization().DrawSelectedLink(player, selLink);
        }
        if (selMes!=null)
        {
          player.network.GetAlgorithm().GetVisualization().DrawSelectedMessage(player, selMes);
        }

        jLabel7.setText("Time: "+((float)Math.round(((float)player.GetRunningTime())/100))/10+" s");
        jLabel5.setText("Messages: "+player.GetActualMessageCount());
        int count=player.GetExceptionCount();
        if (count>0)
        jLabel2.setForeground(Color.RED);
        else
        jLabel2.setForeground(Color.BLACK);
        jLabel2.setText("Exceptions: "+count);
        jLabel4.setText("Asserts: "+player.GetAssertCount());
      }
    };
    jPanel2 = new javax.swing.JPanel();
    jButton1 = new javax.swing.JButton();
    jButton2 = new javax.swing.JButton();
    jButton3 = new javax.swing.JButton();
    jButton4 = new javax.swing.JButton();
    jButton5 = new javax.swing.JButton();
    jButton6 = new javax.swing.JButton();

    jPopupMenu1.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
      public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
      }
      public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
        jPopupMenu1PopupMenuWillBecomeInvisible(evt);
      }
      public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
      }
    });

    jMenuItem1.setText("Node's info");
    jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem1ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem1);

    jMenuItem4.setText("Node's properties");
    jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem4ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem4);

    jPopupMenu2.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
      public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
      }
      public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
        jPopupMenu2PopupMenuWillBecomeInvisible(evt);
      }
      public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
      }
    });

    jMenuItem2.setText("Link's info");
    jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem2ActionPerformed(evt);
      }
    });
    jPopupMenu2.add(jMenuItem2);

    jMenuItem5.setText("Link's properties");
    jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem5ActionPerformed(evt);
      }
    });
    jPopupMenu2.add(jMenuItem5);

    jPopupMenu3.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
      public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
      }
      public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
        jPopupMenu3PopupMenuWillBecomeInvisible(evt);
      }
      public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
      }
    });

    jMenuItem3.setText("Message info");
    jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem3ActionPerformed(evt);
      }
    });
    jPopupMenu3.add(jMenuItem3);

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("VDA");
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
      public void windowOpened(java.awt.event.WindowEvent evt) {
        formWindowOpened(evt);
      }
    });

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel3.setLayout(new java.awt.BorderLayout());

    jPanel4.setLayout(new javax.swing.BoxLayout(jPanel4, javax.swing.BoxLayout.LINE_AXIS));

    jLabel7.setText("Time: 0 s");
    jPanel4.add(jLabel7);

    jLabel6.setText("  ");
    jPanel4.add(jLabel6);

    jLabel5.setText("Messages: 0");
    jPanel4.add(jLabel5);

    jLabel1.setText("  ");
    jPanel4.add(jLabel1);

    jLabel2.setText("Exceptions: 0");
    jPanel4.add(jLabel2);

    jLabel3.setText("  ");
    jPanel4.add(jLabel3);

    jLabel4.setText("Asserts: 0");
    jPanel4.add(jLabel4);

    jPanel3.add(jPanel4, java.awt.BorderLayout.SOUTH);

    jPanel5.setBackground(new java.awt.Color(255, 255, 255));
    jPanel5.setDebugGraphicsOptions(javax.swing.DebugGraphics.NONE_OPTION);
    jPanel5.setFont(new java.awt.Font("Courier New", 0, 11));
    jPanel5.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(java.awt.event.MouseEvent evt) {
        jPanel5MouseReleased(evt);
      }
    });
    jPanel5.setLayout(new java.awt.BorderLayout());
    jPanel3.add(jPanel5, java.awt.BorderLayout.CENTER);

    jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

    jPanel2.setLayout(new java.awt.GridLayout(1, 2, 5, 0));

    jButton1.setText("Start");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });
    jPanel2.add(jButton1);

    jButton2.setText("Pause");
    jButton2.setEnabled(false);
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });
    jPanel2.add(jButton2);

    jButton3.setText("Stop");
    jButton3.setEnabled(false);
    jButton3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton3ActionPerformed(evt);
      }
    });
    jPanel2.add(jButton3);

    jButton4.setText("Statistics");
    jButton4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton4ActionPerformed(evt);
      }
    });
    jPanel2.add(jButton4);

    jButton5.setText("Exceptions");
    jButton5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton5ActionPerformed(evt);
      }
    });
    jPanel2.add(jButton5);

    jButton6.setText("Assert log");
    jButton6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton6ActionPerformed(evt);
      }
    });
    jPanel2.add(jButton6);

    getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-568)/2, (screenSize.height-351)/2, 568, 351);
  }// </editor-fold>//GEN-END:initComponents

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
  player.Stop();
  if (caller!=null)
  {
    caller.setVisible(true);
  }
  dispose();
}//GEN-LAST:event_formWindowClosing

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
  player.Start();
  jButton1.setEnabled(false);
  jButton2.setEnabled(true);
  jButton3.setEnabled(true);
  jButton4.setEnabled(false);
  jButton5.setEnabled(false);
  jButton6.setEnabled(false);
}//GEN-LAST:event_jButton1ActionPerformed

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
  if (player.GetStatus()==Player.STATUS_STARTED)
  {
    jButton1.setEnabled(true);
    jButton2.setEnabled(true);
    jButton3.setEnabled(true);
    jButton4.setEnabled(true);
    jButton5.setEnabled(true);
    jButton6.setEnabled(true);
  }
  else if (player.GetStatus()==Player.STATUS_PAUSED)
  {
    jButton1.setEnabled(false);
    jButton2.setEnabled(true);
    jButton3.setEnabled(true);
    jButton4.setEnabled(false);
    jButton5.setEnabled(false);
    jButton6.setEnabled(false);
  }
  player.Pause();
  jPanel1.repaint();
}//GEN-LAST:event_jButton2ActionPerformed

private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
  player.Stop();
  jButton1.setEnabled(true);
  jButton2.setEnabled(false);
  jButton3.setEnabled(false);
  jButton4.setEnabled(true);
  jButton5.setEnabled(true);
  jButton6.setEnabled(true);
}//GEN-LAST:event_jButton3ActionPerformed

private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
  //load nodes dimension
  Point p=network.GetAlgorithm().GetActivatedVisualizationData().GetNodeDimension();
  for (int i=0;i<network.nodes.length;i++)
  {
    network.nodes[i].dimension=p;
  }
}//GEN-LAST:event_formWindowOpened

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
  StatisticsDialog dial=new StatisticsDialog(player, this, true);
  dial.setVisible(true);
}//GEN-LAST:event_jButton4ActionPerformed

private void jPanel5MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel5MouseReleased
  selNode=null;
  selLink=null;
  selMes=null;
  if ((player.GetStatus()==Player.STATUS_PAUSED) && (evt.getButton()==MouseEvent.BUTTON3))
  {
    Point point=evt.getPoint();
    if ((selMes=player.GetMessageAtPosition(point.x, point.y))!=null)
    {
      jPopupMenu3.show(jPanel1, point.x, point.y);
    }
    else if ((selNode=network.GetNodeAtPosition(point))!=null)
    {
      jPopupMenu1.show(jPanel1, point.x, point.y);
    }
    else if ((selLink=network.GetLinkAtPosition(point))!=null)
    {
      jPopupMenu2.show(jPanel1, point.x, point.y);
    }
  }
  else
  {
    selNode=null;
    selLink=null;
    selMes=null;
  }
  jPanel1.repaint();
}//GEN-LAST:event_jPanel5MouseReleased

private void jPopupMenu1PopupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_jPopupMenu1PopupMenuWillBecomeInvisible
  jPanel1.repaint();
}//GEN-LAST:event_jPopupMenu1PopupMenuWillBecomeInvisible

private void jPopupMenu2PopupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_jPopupMenu2PopupMenuWillBecomeInvisible
  jPopupMenu1PopupMenuWillBecomeInvisible(null);
}//GEN-LAST:event_jPopupMenu2PopupMenuWillBecomeInvisible

private void jPopupMenu3PopupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_jPopupMenu3PopupMenuWillBecomeInvisible
  jPopupMenu1PopupMenuWillBecomeInvisible(null);
}//GEN-LAST:event_jPopupMenu3PopupMenuWillBecomeInvisible

private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
  if (selNode!=null)
  {
    NodeInfoDialog dial=new NodeInfoDialog(player, selNode, this, true);
    dial.setVisible(true);
    selNode=null;
    jPanel1.repaint();
  }
}//GEN-LAST:event_jMenuItem1ActionPerformed

private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
  if (selMes!=null)
  {
    MessageInfoDialog dial=new MessageInfoDialog(selMes, this, true);
    dial.setVisible(true);
    selMes=null;
    jPanel1.repaint();
  }
}//GEN-LAST:event_jMenuItem3ActionPerformed

private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
  if (selLink!=null)
  {
    LinkInfoDialog dial=new LinkInfoDialog(player, selLink, this, true);
    dial.setVisible(true);
    selLink=null;
    jPanel1.repaint();
  }
}//GEN-LAST:event_jMenuItem2ActionPerformed

private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
  if ((player.GetStatus()==Player.STATUS_PAUSED) || (player.GetStatus()==Player.STATUS_STOPPED))
  {
    TextDialog dial=new TextDialog(player.GetExceptions(), this, true);
    dial.setTitle("Exceptions");
    dial.setVisible(true);
  }
}//GEN-LAST:event_jButton5ActionPerformed

private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
  if (selNode!=null)
  {
    NodeDialog dial=new NodeDialog(selNode, this, true, true);
    dial.setVisible(true);
    selNode=null;
    jPanel1.repaint();
  }
}//GEN-LAST:event_jMenuItem4ActionPerformed

private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
  if (selLink!=null)
  {
    LinkDialog dial=new LinkDialog(selLink, this, true);
    dial.setVisible(true);
    selLink=null;
    jPanel1.repaint();
  }
}//GEN-LAST:event_jMenuItem5ActionPerformed

private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
  if ((player.GetStatus()==Player.STATUS_PAUSED) || (player.GetStatus()==Player.STATUS_STOPPED))
  {
    TextDialog dial=new TextDialog(player.GetAssert(), this, true);
    dial.setTitle("Assert log");
    dial.setVisible(true);
  }
}//GEN-LAST:event_jButton6ActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.JButton jButton1;
  public javax.swing.JButton jButton2;
  public javax.swing.JButton jButton3;
  public javax.swing.JButton jButton4;
  public javax.swing.JButton jButton5;
  public javax.swing.JButton jButton6;
  public javax.swing.JLabel jLabel1;
  public javax.swing.JLabel jLabel2;
  public javax.swing.JLabel jLabel3;
  public javax.swing.JLabel jLabel4;
  public javax.swing.JLabel jLabel5;
  public javax.swing.JLabel jLabel6;
  public javax.swing.JLabel jLabel7;
  public javax.swing.JMenuItem jMenuItem1;
  public javax.swing.JMenuItem jMenuItem2;
  public javax.swing.JMenuItem jMenuItem3;
  public javax.swing.JMenuItem jMenuItem4;
  public javax.swing.JMenuItem jMenuItem5;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JPanel jPanel3;
  public javax.swing.JPanel jPanel4;
  public javax.swing.JPanel jPanel5;
  public javax.swing.JPopupMenu jPopupMenu1;
  public javax.swing.JPopupMenu jPopupMenu2;
  public javax.swing.JPopupMenu jPopupMenu3;
  // End of variables declaration//GEN-END:variables
  
}
