/*
 * ElectionNodeDialog.java
 *
 * Created on Nedea, 2008, mj 4, 23:36
 */

package form.dialog;

import javax.swing.JCheckBox;
import javax.swing.JFormattedTextField;
import network.Constraint;
import network.NetworkConstraint;
import network.NodeConstraint;
import other.Functions;
import other.Global;

/**
 *
 * @author  Dur
 */
public class ConstraintDialog extends javax.swing.JDialog {
  private Constraint constraintIn, constraintOut=null;
  private boolean isLoaded=false;
  
  /**
   * Creates new form ElectionNodeDialog
   */
  public ConstraintDialog(Constraint constraint, java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
    getRootPane().setDefaultButton(jButton1);
    
    constraintIn=constraint;
    if (constraintIn==null)
    {
      constraintIn=new NetworkConstraint();
    }
    
    UpdateForm();
    isLoaded=true;
  }
  
  private void SetConstraintEnabled(int constraintNum, boolean enabled)
  {
    if (constraintNum==0)
    {
      jCheckBox3.setEnabled(enabled);
      jFormattedTextField3.setEnabled(enabled);
      jComboBox1.setEnabled(enabled);
      jFormattedTextField4.setEnabled(enabled);
      if (enabled==false)
      {
        jCheckBox3.setSelected(false);
        jFormattedTextField3.setValue(0);
        jComboBox1.setSelectedIndex(2);
        jFormattedTextField4.setValue(0);
      }
    }
    if (constraintNum==1)
    {
      jCheckBox4.setEnabled(enabled);
      jFormattedTextField5.setEnabled(enabled);
      jCheckBox5.setEnabled(enabled);
      jFormattedTextField6.setEnabled(enabled);
      jComboBox2.setEnabled(enabled);
      jFormattedTextField7.setEnabled(enabled);
      if (enabled==false)
      {
        jCheckBox4.setSelected(false);
        jFormattedTextField5.setValue(0);
        jCheckBox5.setSelected(false);
        jFormattedTextField6.setValue(0);
        jComboBox2.setEnabled(enabled);
        jFormattedTextField7.setValue(0);
      }
    }
  }
  
  private void ShowMultiValue(Object value, JFormattedTextField field, JCheckBox box)
  {
    if (value==null)
    {
      field.setValue(0);
      field.setEnabled(false);
      box.setSelected(false);
    }
    else
    {
      field.setValue(value);
      field.setEnabled(true);
      box.setSelected(true);
    }
  }
  
  public Integer GetMultiValue(JFormattedTextField field, JCheckBox box)
  {
    if (box.isSelected())
    {
      return Functions.intVal(field.getValue().toString());
    }
    return null;
  }
  
  public void UpdateForm()
  {
    try
    {
      if (constraintIn instanceof NetworkConstraint)
      {
        isLoaded=false;
        jRadioButton1.setSelected(true);
        isLoaded=true;
        SetConstraintEnabled(0, true);
        SetConstraintEnabled(1, false);
        NetworkConstraint c=(NetworkConstraint)constraintIn;
        ShowMultiValue(c.messageNum, jFormattedTextField1, jCheckBox1);
        ShowMultiValue(c.messageType, jFormattedTextField2, jCheckBox2);
        ShowMultiValue(c.currentMessageType, jFormattedTextField3, jCheckBox3);
        jComboBox1.setSelectedIndex(c.currentMessageOperator);
        jFormattedTextField4.setValue(c.currentMessageCount);
      }
      else if (constraintIn instanceof NodeConstraint)
      {
        isLoaded=false;
        jRadioButton2.setSelected(true);
        isLoaded=true;
        SetConstraintEnabled(0, false);
        SetConstraintEnabled(1, true);
        NodeConstraint c=(NodeConstraint)constraintIn;
        ShowMultiValue(c.messageNum, jFormattedTextField1, jCheckBox1);
        ShowMultiValue(c.messageType, jFormattedTextField2, jCheckBox2);
        ShowMultiValue(c.currentMessageType, jFormattedTextField5, jCheckBox4);
        ShowMultiValue(c.nodeId, jFormattedTextField6, jCheckBox5);
        jComboBox2.setSelectedIndex(c.currentMessageOperator);
        jFormattedTextField7.setValue(c.currentMessageCount);
      }
      else
      {
        SetConstraintEnabled(0, false);
        SetConstraintEnabled(1, false);
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->ConstraintDialog->UpdateForm",e);
    }
  }
  
  public void UpdateData()
  {
    try
    {
      if (jRadioButton1.isSelected())
      {
        NetworkConstraint c=new NetworkConstraint();
        c.messageNum=GetMultiValue(jFormattedTextField1, jCheckBox1);
        c.messageType=GetMultiValue(jFormattedTextField2, jCheckBox2);
        c.currentMessageType=GetMultiValue(jFormattedTextField3, jCheckBox3);
        c.currentMessageOperator=jComboBox1.getSelectedIndex();
        c.currentMessageCount=Functions.intVal(jFormattedTextField4.getValue().toString());
        constraintIn=c;
      }
      else if (jRadioButton2.isSelected())
      {
        NodeConstraint c=new NodeConstraint();
        c.messageNum=GetMultiValue(jFormattedTextField1, jCheckBox1);
        c.messageType=GetMultiValue(jFormattedTextField2, jCheckBox2);
        c.currentMessageType=GetMultiValue(jFormattedTextField5, jCheckBox4);
        c.nodeId=GetMultiValue(jFormattedTextField6, jCheckBox5);
        c.currentMessageOperator=jComboBox2.getSelectedIndex();
        c.currentMessageCount=Functions.intVal(jFormattedTextField7.getValue().toString());
        constraintIn=c;
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->ConstraintDialog->UpdateData",e);
    }
  }
  
  public Constraint GetConstraint()
  {
    return constraintOut;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    buttonGroup1 = new javax.swing.ButtonGroup();
    jPanel1 = new javax.swing.JPanel();
    jButton1 = new javax.swing.JButton();
    jButton2 = new javax.swing.JButton();
    jPanel8 = new javax.swing.JPanel();
    jPanel6 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    jCheckBox1 = new javax.swing.JCheckBox();
    jFormattedTextField1 = new javax.swing.JFormattedTextField();
    jLabel1 = new javax.swing.JLabel();
    jCheckBox2 = new javax.swing.JCheckBox();
    jFormattedTextField2 = new javax.swing.JFormattedTextField();
    jLabel2 = new javax.swing.JLabel();
    jPanel10 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    jRadioButton1 = new javax.swing.JRadioButton();
    jLabel3 = new javax.swing.JLabel();
    jCheckBox3 = new javax.swing.JCheckBox();
    jFormattedTextField3 = new javax.swing.JFormattedTextField();
    jLabel4 = new javax.swing.JLabel();
    jComboBox1 = new javax.swing.JComboBox();
    jLabel5 = new javax.swing.JLabel();
    jFormattedTextField4 = new javax.swing.JFormattedTextField();
    jLabel9 = new javax.swing.JLabel();
    jPanel5 = new javax.swing.JPanel();
    jPanel9 = new javax.swing.JPanel();
    jRadioButton2 = new javax.swing.JRadioButton();
    jLabel6 = new javax.swing.JLabel();
    jCheckBox4 = new javax.swing.JCheckBox();
    jFormattedTextField5 = new javax.swing.JFormattedTextField();
    jLabel7 = new javax.swing.JLabel();
    jCheckBox5 = new javax.swing.JCheckBox();
    jFormattedTextField6 = new javax.swing.JFormattedTextField();
    jLabel10 = new javax.swing.JLabel();
    jComboBox2 = new javax.swing.JComboBox();
    jLabel8 = new javax.swing.JLabel();
    jFormattedTextField7 = new javax.swing.JFormattedTextField();
    jPanel7 = new javax.swing.JPanel();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Constraint");
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
    });

    jButton1.setText("OK");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton1);

    jButton2.setText("Cancel");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton2);

    getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);
    getContentPane().add(jPanel8, java.awt.BorderLayout.LINE_END);
    getContentPane().add(jPanel6, java.awt.BorderLayout.WEST);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jCheckBox1.setSelected(true);
    jCheckBox1.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        jCheckBox1ItemStateChanged(evt);
      }
    });
    jPanel3.add(jCheckBox1);

    jFormattedTextField1.setPreferredSize(new java.awt.Dimension(50, 21));
    jPanel3.add(jFormattedTextField1);

    jLabel1.setText("message of type");
    jPanel3.add(jLabel1);

    jCheckBox2.setSelected(true);
    jCheckBox2.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        jCheckBox2ItemStateChanged(evt);
      }
    });
    jPanel3.add(jCheckBox2);

    jFormattedTextField2.setPreferredSize(new java.awt.Dimension(50, 21));
    jPanel3.add(jFormattedTextField2);

    jLabel2.setText("can be sent");
    jPanel3.add(jLabel2);

    jPanel2.add(jPanel3, java.awt.BorderLayout.PAGE_START);

    jPanel10.setLayout(new java.awt.BorderLayout());

    buttonGroup1.add(jRadioButton1);
    jRadioButton1.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        jRadioButton1ItemStateChanged(evt);
      }
    });
    jPanel4.add(jRadioButton1);

    jLabel3.setText("if number of actually sending messages of type");
    jPanel4.add(jLabel3);

    jCheckBox3.setSelected(true);
    jCheckBox3.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        jCheckBox3ItemStateChanged(evt);
      }
    });
    jPanel4.add(jCheckBox3);

    jFormattedTextField3.setPreferredSize(new java.awt.Dimension(50, 21));
    jPanel4.add(jFormattedTextField3);

    jLabel4.setText("in network is");
    jPanel4.add(jLabel4);

    jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "<", "<=", "=", ">=", ">" }));
    jPanel4.add(jComboBox1);

    jLabel5.setText("than");
    jPanel4.add(jLabel5);

    jFormattedTextField4.setPreferredSize(new java.awt.Dimension(50, 21));
    jPanel4.add(jFormattedTextField4);

    jLabel9.setText("               ");
    jPanel4.add(jLabel9);

    jPanel10.add(jPanel4, java.awt.BorderLayout.PAGE_START);

    jPanel5.setLayout(new java.awt.BorderLayout());

    buttonGroup1.add(jRadioButton2);
    jRadioButton2.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        jRadioButton2ItemStateChanged(evt);
      }
    });
    jPanel9.add(jRadioButton2);

    jLabel6.setText("if number of messages of type");
    jPanel9.add(jLabel6);

    jCheckBox4.setSelected(true);
    jCheckBox4.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        jCheckBox4ItemStateChanged(evt);
      }
    });
    jPanel9.add(jCheckBox4);

    jFormattedTextField5.setPreferredSize(new java.awt.Dimension(50, 21));
    jPanel9.add(jFormattedTextField5);

    jLabel7.setText("sent by node with id");
    jPanel9.add(jLabel7);

    jCheckBox5.setSelected(true);
    jCheckBox5.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        jCheckBox5ItemStateChanged(evt);
      }
    });
    jPanel9.add(jCheckBox5);

    jFormattedTextField6.setPreferredSize(new java.awt.Dimension(50, 21));
    jPanel9.add(jFormattedTextField6);

    jLabel10.setText("is");
    jPanel9.add(jLabel10);

    jComboBox2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "<", "<=", "=", ">=", ">" }));
    jPanel9.add(jComboBox2);

    jLabel8.setText("than");
    jPanel9.add(jLabel8);

    jFormattedTextField7.setPreferredSize(new java.awt.Dimension(50, 21));
    jPanel9.add(jFormattedTextField7);

    jPanel5.add(jPanel9, java.awt.BorderLayout.PAGE_START);

    jPanel10.add(jPanel5, java.awt.BorderLayout.CENTER);

    jPanel2.add(jPanel10, java.awt.BorderLayout.CENTER);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);
    getContentPane().add(jPanel7, java.awt.BorderLayout.PAGE_START);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-626)/2, (screenSize.height-175)/2, 626, 175);
  }// </editor-fold>//GEN-END:initComponents

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
  formWindowClosing(null);
}//GEN-LAST:event_jButton2ActionPerformed

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
  setVisible(false);
  dispose();
}//GEN-LAST:event_formWindowClosing

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
  UpdateData();
  constraintOut=constraintIn;
  formWindowClosing(null);
}//GEN-LAST:event_jButton1ActionPerformed

private void jCheckBox1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox1ItemStateChanged
  jFormattedTextField1.setEnabled(jCheckBox1.isSelected());
}//GEN-LAST:event_jCheckBox1ItemStateChanged

private void jRadioButton1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jRadioButton1ItemStateChanged
  if (isLoaded && jRadioButton1.isSelected())
  {
    NetworkConstraint c=new NetworkConstraint();
    c.messageNum=GetMultiValue(jFormattedTextField1, jCheckBox1);
    c.messageType=GetMultiValue(jFormattedTextField2, jCheckBox2);
    constraintIn=c;
    UpdateForm();
  }
}//GEN-LAST:event_jRadioButton1ItemStateChanged

private void jRadioButton2ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jRadioButton2ItemStateChanged
  if (isLoaded && jRadioButton2.isSelected())
  {
    NodeConstraint c=new NodeConstraint();
    c.messageNum=GetMultiValue(jFormattedTextField1, jCheckBox1);
    c.messageType=GetMultiValue(jFormattedTextField2, jCheckBox2);
    constraintIn=c;
    UpdateForm();
  }
}//GEN-LAST:event_jRadioButton2ItemStateChanged

private void jCheckBox2ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox2ItemStateChanged
  jFormattedTextField2.setEnabled(jCheckBox2.isSelected());
}//GEN-LAST:event_jCheckBox2ItemStateChanged

private void jCheckBox3ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox3ItemStateChanged
  jFormattedTextField3.setEnabled(jCheckBox3.isSelected());
}//GEN-LAST:event_jCheckBox3ItemStateChanged

private void jCheckBox4ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox4ItemStateChanged
  jFormattedTextField5.setEnabled(jCheckBox4.isSelected());
}//GEN-LAST:event_jCheckBox4ItemStateChanged

private void jCheckBox5ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox5ItemStateChanged
  jFormattedTextField6.setEnabled(jCheckBox5.isSelected());
}//GEN-LAST:event_jCheckBox5ItemStateChanged
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.ButtonGroup buttonGroup1;
  public javax.swing.JButton jButton1;
  public javax.swing.JButton jButton2;
  public javax.swing.JCheckBox jCheckBox1;
  public javax.swing.JCheckBox jCheckBox2;
  public javax.swing.JCheckBox jCheckBox3;
  public javax.swing.JCheckBox jCheckBox4;
  public javax.swing.JCheckBox jCheckBox5;
  public javax.swing.JComboBox jComboBox1;
  public javax.swing.JComboBox jComboBox2;
  public javax.swing.JFormattedTextField jFormattedTextField1;
  public javax.swing.JFormattedTextField jFormattedTextField2;
  public javax.swing.JFormattedTextField jFormattedTextField3;
  public javax.swing.JFormattedTextField jFormattedTextField4;
  public javax.swing.JFormattedTextField jFormattedTextField5;
  public javax.swing.JFormattedTextField jFormattedTextField6;
  public javax.swing.JFormattedTextField jFormattedTextField7;
  public javax.swing.JLabel jLabel1;
  public javax.swing.JLabel jLabel10;
  public javax.swing.JLabel jLabel2;
  public javax.swing.JLabel jLabel3;
  public javax.swing.JLabel jLabel4;
  public javax.swing.JLabel jLabel5;
  public javax.swing.JLabel jLabel6;
  public javax.swing.JLabel jLabel7;
  public javax.swing.JLabel jLabel8;
  public javax.swing.JLabel jLabel9;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel10;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JPanel jPanel3;
  public javax.swing.JPanel jPanel4;
  public javax.swing.JPanel jPanel5;
  public javax.swing.JPanel jPanel6;
  public javax.swing.JPanel jPanel7;
  public javax.swing.JPanel jPanel8;
  public javax.swing.JPanel jPanel9;
  public javax.swing.JRadioButton jRadioButton1;
  public javax.swing.JRadioButton jRadioButton2;
  // End of variables declaration//GEN-END:variables
  
}
