/*
 * ElectionNodeDialog.java
 *
 * Created on Nedea, 2008, mj 4, 23:36
 */

package form.dialog;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;
import network.Constraint;
import network.Link;
import network.NetworkConstraint;
import network.NodeConstraint;
import other.Global;
import other.IDialog;

/**
 *
 * @author  Dur
 */
public class LinkDialog extends javax.swing.JDialog implements IDialog
{
  protected Link link;
  protected boolean isOKPressed=false;
  protected Constraint[] constraints;
  
  /**
   * Creates new form ElectionNodeDialog
   */
  private LinkDialog(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
    getRootPane().setDefaultButton(jButton1);
    DefaultComboBoxModel model=new DefaultComboBoxModel();
    model.addElement(new Boolean(false));
    model.addElement(new Boolean(true));
    jComboBox1.setModel(model);
    jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() 
    {
      public void valueChanged(ListSelectionEvent e) {
        if (jTable1.getSelectedRow()==-1)
        {
          jButton4.setEnabled(false);
          jButton5.setEnabled(false);
        }
        else
        {
          jButton4.setEnabled(true);
          jButton5.setEnabled(true);
        }
      }
    });
  }
  
  public LinkDialog(Link link, java.awt.Frame parent, boolean modal) {
    this(parent, modal);
    this.link=link;
    this.constraints=link.constraints;
    UpdateForm();
  }
  
  public void SetFormReadonly()
  {
    try
    {
      
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->LinkDialog->SetFormReadonly",e);
    }
  }
  
  public void UpdateForm()
  {
    try
    {
      if (link!=null)
      {
        if (link.prop.get("active").equals(new Boolean(true)))
        {
          jComboBox1.setSelectedIndex(1);
        }
        else
        {
          jComboBox1.setSelectedIndex(0);
        }
        jSpinner1.setValue(link.prop.get("activationTimer"));
        jSpinner2.setValue(link.prop.get("transferSpeed"));
        DefaultTableModel model=(DefaultTableModel)jTable1.getModel();
        model.setNumRows(0);
        for (int i=0;i<link.constraints.length;i++)
        {
          if (link.constraints[i] instanceof NetworkConstraint)
          {
            model.addRow(new Object[]{"Network constraint"});
          }
          else if (link.constraints[i] instanceof NodeConstraint)
          {
            model.addRow(new Object[]{"Node constraint"});
          }
        }
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->LinkDialog->UpdateForm",e);
    }
  }
  
  public void UpdateLink()
  {
    try
    {
      if (link!=null)
      {
        link.prop.put("active", jComboBox1.getSelectedItem());
        link.prop.put("activationTimer", jSpinner1.getValue());
        link.prop.put("transferSpeed", jSpinner2.getValue());
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->LinkDialog->UpdateLink",e);
    }
  }
  
  public boolean IsOKPressed()
  {
    return isOKPressed;
  }
  
  @Override
  public void setVisible(boolean b)
  {
    super.setVisible(b);
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPopupMenu1 = new javax.swing.JPopupMenu();
    jMenuItem1 = new javax.swing.JMenuItem();
    jMenuItem2 = new javax.swing.JMenuItem();
    jMenuItem3 = new javax.swing.JMenuItem();
    jPanel1 = new javax.swing.JPanel();
    jButton1 = new javax.swing.JButton();
    jButton2 = new javax.swing.JButton();
    jPanel8 = new javax.swing.JPanel();
    jPanel6 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    jLabel4 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();
    jLabel1 = new javax.swing.JLabel();
    jPanel5 = new javax.swing.JPanel();
    jComboBox1 = new javax.swing.JComboBox();
    jSpinner1 = new javax.swing.JSpinner();
    jSpinner2 = new javax.swing.JSpinner();
    jPanel12 = new javax.swing.JPanel();
    jPanel13 = new javax.swing.JPanel();
    jButton3 = new javax.swing.JButton();
    jButton4 = new javax.swing.JButton();
    jButton5 = new javax.swing.JButton();
    jScrollPane1 = new javax.swing.JScrollPane();
    jTable1 = new javax.swing.JTable();
    jPanel9 = new javax.swing.JPanel();
    jPanel7 = new javax.swing.JPanel();

    jPopupMenu1.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
      public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
      }
      public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
      }
      public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
        jPopupMenu1PopupMenuWillBecomeVisible(evt);
      }
    });

    jMenuItem1.setText("New constraint");
    jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem1ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem1);

    jMenuItem2.setText("Edit constraint");
    jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem2ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem2);

    jMenuItem3.setText("Delete constraint");
    jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem3ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem3);

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Link properties");
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
    });

    jButton1.setText("OK");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton1);

    jButton2.setText("Cancel");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton2);

    getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);
    getContentPane().add(jPanel8, java.awt.BorderLayout.LINE_END);
    getContentPane().add(jPanel6, java.awt.BorderLayout.WEST);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel3.setLayout(new java.awt.BorderLayout());

    jPanel4.setLayout(new java.awt.GridLayout(0, 1, 0, 3));

    jLabel4.setText("Active: ");
    jPanel4.add(jLabel4);

    jLabel3.setText("Activation timer (ms): ");
    jPanel4.add(jLabel3);

    jLabel1.setText("Transfer speed (ms): ");
    jPanel4.add(jLabel1);

    jPanel3.add(jPanel4, java.awt.BorderLayout.WEST);

    jPanel5.setLayout(new java.awt.GridLayout(0, 1, 0, 3));

    jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
    jPanel5.add(jComboBox1);

    jSpinner1.setPreferredSize(new java.awt.Dimension(25, 20));
    jPanel5.add(jSpinner1);

    jSpinner2.setPreferredSize(new java.awt.Dimension(25, 20));
    jPanel5.add(jSpinner2);

    jPanel3.add(jPanel5, java.awt.BorderLayout.CENTER);

    jPanel2.add(jPanel3, java.awt.BorderLayout.PAGE_START);

    jPanel12.setLayout(new java.awt.BorderLayout());

    jButton3.setText("New constraint");
    jButton3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton3ActionPerformed(evt);
      }
    });
    jPanel13.add(jButton3);

    jButton4.setText("Edit constraint");
    jButton4.setEnabled(false);
    jButton4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton4ActionPerformed(evt);
      }
    });
    jPanel13.add(jButton4);

    jButton5.setText("Delete constraint");
    jButton5.setEnabled(false);
    jButton5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton5ActionPerformed(evt);
      }
    });
    jPanel13.add(jButton5);

    jPanel12.add(jPanel13, java.awt.BorderLayout.PAGE_END);

    jTable1.setModel(new javax.swing.table.DefaultTableModel(
      new Object [][] {

      },
      new String [] {
        "Constraint type"
      }
    ) {
      boolean[] canEdit = new boolean [] {
        false
      };

      public boolean isCellEditable(int rowIndex, int columnIndex) {
        return canEdit [columnIndex];
      }
    });
    jTable1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        jTable1MouseClicked(evt);
      }
      public void mouseReleased(java.awt.event.MouseEvent evt) {
        jTable1MouseReleased(evt);
      }
    });
    jScrollPane1.setViewportView(jTable1);

    jPanel12.add(jScrollPane1, java.awt.BorderLayout.CENTER);
    jPanel12.add(jPanel9, java.awt.BorderLayout.PAGE_START);

    jPanel2.add(jPanel12, java.awt.BorderLayout.CENTER);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);
    getContentPane().add(jPanel7, java.awt.BorderLayout.PAGE_START);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-519)/2, (screenSize.height-382)/2, 519, 382);
  }// </editor-fold>//GEN-END:initComponents

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
  link.constraints=constraints;
  formWindowClosing(null);
}//GEN-LAST:event_jButton2ActionPerformed

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
  setVisible(false);
  dispose();
}//GEN-LAST:event_formWindowClosing

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
  isOKPressed=true;
  UpdateLink();
  formWindowClosing(null);
}//GEN-LAST:event_jButton1ActionPerformed

private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
  try
  {
    ConstraintDialog dial=new ConstraintDialog(null, null, true);
    dial.setVisible(true);
    Constraint con=dial.GetConstraint();
    if (con!=null)
    {
      link.AddConstraint(con);
      UpdateForm();
    }
  }
  catch (Exception e)
  {
    Global.errorLog.Write("form->dialog->LinkDialog->jButton3ActionPerformed",e);
  }
}//GEN-LAST:event_jButton3ActionPerformed

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
  try
  {
    ConstraintDialog dial=new ConstraintDialog(link.constraints[jTable1.getSelectedRow()], null, true);
    dial.setVisible(true);
    Constraint con=dial.GetConstraint();
    if (con!=null)
    {
      link.constraints[jTable1.getSelectedRow()]=con;
      UpdateForm();
    }
  }
  catch (Exception e)
  {
    Global.errorLog.Write("form->dialog->LinkDialog->jButton4ActionPerformed",e);
  }
}//GEN-LAST:event_jButton4ActionPerformed

private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
  try
  {
    if (JOptionPane.showConfirmDialog(this, "Do you really want to delete selected constraint?", "Delete", JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION)
    {
      link.DeleteConstraint(jTable1.getSelectedRow());
      UpdateForm();
    }
  }
  catch (Exception e)
  {
    Global.errorLog.Write("form->dialog->LinkDialog->jButton5ActionPerformed",e);
  }
}//GEN-LAST:event_jButton5ActionPerformed

private void jTable1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseClicked
if ((evt!=null) && (evt.getClickCount()>1))
  {
    jButton4ActionPerformed(null);
  }
}//GEN-LAST:event_jTable1MouseClicked

private void jTable1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseReleased
if ((evt!=null) && (evt.isPopupTrigger()))
  {
    jPopupMenu1.show(jTable1, evt.getX(), evt.getY());
  }
}//GEN-LAST:event_jTable1MouseReleased

private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
  jButton3ActionPerformed(null);
}//GEN-LAST:event_jMenuItem1ActionPerformed

private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
  jButton4ActionPerformed(null);
}//GEN-LAST:event_jMenuItem2ActionPerformed

private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
  jButton5ActionPerformed(null);
}//GEN-LAST:event_jMenuItem3ActionPerformed

private void jPopupMenu1PopupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_jPopupMenu1PopupMenuWillBecomeVisible
  jMenuItem2.setEnabled(jTable1.getSelectedRow()>-1);
  jMenuItem3.setEnabled(jTable1.getSelectedRow()>-1);
}//GEN-LAST:event_jPopupMenu1PopupMenuWillBecomeVisible
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.JButton jButton1;
  public javax.swing.JButton jButton2;
  public javax.swing.JButton jButton3;
  public javax.swing.JButton jButton4;
  public javax.swing.JButton jButton5;
  public javax.swing.JComboBox jComboBox1;
  public javax.swing.JLabel jLabel1;
  public javax.swing.JLabel jLabel3;
  public javax.swing.JLabel jLabel4;
  public javax.swing.JMenuItem jMenuItem1;
  public javax.swing.JMenuItem jMenuItem2;
  public javax.swing.JMenuItem jMenuItem3;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel12;
  public javax.swing.JPanel jPanel13;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JPanel jPanel3;
  public javax.swing.JPanel jPanel4;
  public javax.swing.JPanel jPanel5;
  public javax.swing.JPanel jPanel6;
  public javax.swing.JPanel jPanel7;
  public javax.swing.JPanel jPanel8;
  public javax.swing.JPanel jPanel9;
  public javax.swing.JPopupMenu jPopupMenu1;
  public javax.swing.JScrollPane jScrollPane1;
  public javax.swing.JSpinner jSpinner1;
  public javax.swing.JSpinner jSpinner2;
  public javax.swing.JTable jTable1;
  // End of variables declaration//GEN-END:variables
  
}
