/*
 * ElectionNodeDialog.java
 *
 * Created on Nedea, 2008, mj 4, 23:36
 */

package form.dialog;

import java.awt.Color;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.TreeMap;
import javax.swing.table.DefaultTableModel;
import network.Link;
import network.LinkMessage;
import network.Node;
import other.Global;
import player.Player;

/**
 *
 * @author  Dur
 */
public class LinkInfoDialog extends javax.swing.JDialog {
  protected Link link;
  protected Player player;
  /**
   * Creates new form ElectionNodeDialog
   */
  public LinkInfoDialog(Player player, Link link, java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
    getRootPane().setDefaultButton(jButton2);
    this.link=link;
    this.player=player;
    UpdateForm();
  }
  
  public void UpdateForm()
  {
    try
    {
      DefaultTableModel model=(DefaultTableModel) jTable1.getModel();
      model.setNumRows(0);
      TreeMap<Integer, Color> colors=player.network.GetAlgorithm().GetActivatedVisualizationData().messageTypesBgColors;
      synchronized (player.linksThread.constraints)
      {
        LinkedList<LinkMessage>[] lists=new LinkedList[]{null,null};
        HashMap<Node,LinkedList<LinkMessage>> map=player.linksThread.constraints.get(link.GetFirstNode());
        if (map!=null)
        {
          lists[0]=map.get(link.GetSecondNode());
        }
        map=player.linksThread.constraints.get(link.GetSecondNode());
        if (map!=null)
        {
          lists[1]=map.get(link.GetFirstNode());
        }
        
        for (int i=0;i<lists.length;i++)
        {
          if (lists[i]!=null)
          {
            Iterator<LinkMessage> it=lists[i].iterator();
            while (it.hasNext())
            {
              LinkMessage mes=it.next();
              boolean isSatisfied=true;
              String pos="all satisfied";
              for (int j=0;j<mes.link.constraints.length;j++)
              {
                if (isSatisfied)
                {
                  if (!mes.link.constraints[j].IsSatisfied(mes))
                  {
                    isSatisfied=false;
                    pos=new Integer(j+1).toString()+".";
                  }
                }
              }
              Object[] o=new Object[]{"",mes.message.GetType(),mes.message.GetObject(),mes.sender.prop.get("id"),pos};
              Color c=colors.get(mes.message.GetType());
              if (c!=null)
                o[0]="<html><body style=\"background-color: rgb("+c.getRed()+", "+c.getGreen()+", "+c.getBlue()+");\"><div style=\"width: 200px;\">&nbsp;</div></body></html>";
              model.addRow(o);
            }
          }
        }
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->LinkInfoDialog->UpdateForm",e);
    }
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPanel1 = new javax.swing.JPanel();
    jButton2 = new javax.swing.JButton();
    jPanel8 = new javax.swing.JPanel();
    jPanel6 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    jPanel10 = new javax.swing.JPanel();
    jPanel11 = new javax.swing.JPanel();
    jLabel1 = new javax.swing.JLabel();
    jScrollPane1 = new javax.swing.JScrollPane();
    jTable1 = new javax.swing.JTable();
    jPanel7 = new javax.swing.JPanel();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Link info");
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
    });

    jButton2.setText("Close");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton2);

    getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);
    getContentPane().add(jPanel8, java.awt.BorderLayout.LINE_END);
    getContentPane().add(jPanel6, java.awt.BorderLayout.WEST);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel10.setLayout(new java.awt.BorderLayout());

    jPanel11.setLayout(new java.awt.BorderLayout());

    jLabel1.setText("Waiting messages: ");
    jPanel11.add(jLabel1, java.awt.BorderLayout.CENTER);

    jPanel10.add(jPanel11, java.awt.BorderLayout.PAGE_START);

    jTable1.setModel(new javax.swing.table.DefaultTableModel(
      new Object [][] {

      },
      new String [] {
        "Color", "Message type", "Message", "Sender's id", "Unsatisfied constraint"
      }
    ) {
      boolean[] canEdit = new boolean [] {
        false, false, false, false, false
      };

      public boolean isCellEditable(int rowIndex, int columnIndex) {
        return canEdit [columnIndex];
      }
    });
    jTable1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jScrollPane1.setViewportView(jTable1);

    jPanel10.add(jScrollPane1, java.awt.BorderLayout.CENTER);

    jPanel2.add(jPanel10, java.awt.BorderLayout.CENTER);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);
    getContentPane().add(jPanel7, java.awt.BorderLayout.PAGE_START);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-657)/2, (screenSize.height-354)/2, 657, 354);
  }// </editor-fold>//GEN-END:initComponents

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
  formWindowClosing(null);
}//GEN-LAST:event_jButton2ActionPerformed

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
  setVisible(false);
  dispose();
}//GEN-LAST:event_formWindowClosing
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.JButton jButton2;
  public javax.swing.JLabel jLabel1;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel10;
  public javax.swing.JPanel jPanel11;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JPanel jPanel6;
  public javax.swing.JPanel jPanel7;
  public javax.swing.JPanel jPanel8;
  public javax.swing.JScrollPane jScrollPane1;
  public javax.swing.JTable jTable1;
  // End of variables declaration//GEN-END:variables
  
}
