/*
 * ElectionNodeDialog.java
 *
 * Created on Nedea, 2008, mj 4, 23:36
 */

package form.dialog;

import java.awt.Color;
import java.util.Map.Entry;
import java.util.TreeMap;
import javax.swing.table.DefaultTableModel;
import network.NetworkConstraint;
import network.Node;
import other.Global;
import player.Player;

/**
 *
 * @author  Dur
 */
public class NodeInfoDialog extends javax.swing.JDialog {
  protected Player player;
  protected Node node;
  /**
   * Creates new form ElectionNodeDialog
   */
  public NodeInfoDialog(Player player, Node node, java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
    getRootPane().setDefaultButton(jButton2);
    this.player=player;
    this.node=node;
    UpdateForm();
  }
  
  public void UpdateForm()
  {
    try
    {
      int index=node.network.GetNodeIndex(node);
      if ((index>=0) && (index<node.network.nodes.length))
      {
        jLabel1.setText(new Integer(NetworkConstraint.numSentMessagesByNode[index]).toString());
        jLabel4.setText(node.prop.get("id").toString());
        DefaultTableModel model=(DefaultTableModel) jTable1.getModel();
        model.setNumRows(0);
        Integer[] types=NetworkConstraint.GetSentMessageTypesByNode(index);
        if (types!=null)
        {
          TreeMap<Integer, Color> colors=player.network.GetAlgorithm().GetActivatedVisualizationData().messageTypesBgColors;
          for (int i=0;i<types.length;i++)
          {
            Object[] o=new Object[]{"",types[i],NetworkConstraint.GetSentMessageCount(types[i],index)};
            Color c=colors.get(types[i]);
            if (c!=null)
              o[0]="<html><body style=\"background-color: rgb("+c.getRed()+", "+c.getGreen()+", "+c.getBlue()+");\"><div style=\"width: 200px;\">&nbsp;</div></body></html>";
            model.addRow(o);
          }
        }
        
        //show properties
        TreeMap<String, Object> tree=new TreeMap<String, Object>();
        synchronized (node.nodeThread.prop)
        {
          Object[] o=node.nodeThread.prop.entrySet().toArray();
          for (int i=0;i<o.length;i++)
          {
            Entry e=(Entry)o[i];
            if (e.getKey()!=null)
              tree.put(e.getKey().toString(), e);
            else
              tree.put(null, e);
          }
          o=tree.values().toArray();
          model=(DefaultTableModel) jTable2.getModel();
          model.setNumRows(0);
          for (int i=0;i<o.length;i++)
          {
            try
            {
              Entry e=(Entry)o[i];
              Object[] r=new Object[2];
              r[0]=e.getKey();
              r[1]=e.getValue();
              model.addRow(r);
            }
            catch (Exception e){}
          }
        }
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->NodeInfoDialog->UpdateForm",e);
    }
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPanel1 = new javax.swing.JPanel();
    jButton2 = new javax.swing.JButton();
    jPanel8 = new javax.swing.JPanel();
    jPanel6 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    jLabel3 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();
    jPanel5 = new javax.swing.JPanel();
    jLabel4 = new javax.swing.JLabel();
    jLabel1 = new javax.swing.JLabel();
    jPanel10 = new javax.swing.JPanel();
    jTabbedPane1 = new javax.swing.JTabbedPane();
    jPanel9 = new javax.swing.JPanel();
    jScrollPane2 = new javax.swing.JScrollPane();
    jTable2 = new javax.swing.JTable();
    jScrollPane1 = new javax.swing.JScrollPane();
    jTable1 = new javax.swing.JTable();
    jPanel11 = new javax.swing.JPanel();
    jPanel7 = new javax.swing.JPanel();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Node info");
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
    });

    jButton2.setText("Close");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton2);

    getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);
    getContentPane().add(jPanel8, java.awt.BorderLayout.LINE_END);
    getContentPane().add(jPanel6, java.awt.BorderLayout.WEST);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel3.setLayout(new java.awt.BorderLayout());

    jPanel4.setLayout(new java.awt.GridLayout(0, 1, 0, 3));

    jLabel3.setText("Id: ");
    jPanel4.add(jLabel3);

    jLabel2.setText("Total number of sent messages: ");
    jPanel4.add(jLabel2);

    jPanel3.add(jPanel4, java.awt.BorderLayout.WEST);

    jPanel5.setLayout(new java.awt.GridLayout(0, 1, 0, 3));
    jPanel5.add(jLabel4);

    jLabel1.setText("0");
    jPanel5.add(jLabel1);

    jPanel3.add(jPanel5, java.awt.BorderLayout.CENTER);

    jPanel2.add(jPanel3, java.awt.BorderLayout.PAGE_START);

    jPanel10.setLayout(new java.awt.BorderLayout());

    jPanel9.setLayout(new java.awt.BorderLayout());

    jTable2.setModel(new javax.swing.table.DefaultTableModel(
      new Object [][] {

      },
      new String [] {
        "Property", "Value"
      }
    ) {
      boolean[] canEdit = new boolean [] {
        false, false
      };

      public boolean isCellEditable(int rowIndex, int columnIndex) {
        return canEdit [columnIndex];
      }
    });
    jTable2.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jScrollPane2.setViewportView(jTable2);

    jPanel9.add(jScrollPane2, java.awt.BorderLayout.CENTER);

    jTabbedPane1.addTab("Properties", jPanel9);

    jTable1.setModel(new javax.swing.table.DefaultTableModel(
      new Object [][] {

      },
      new String [] {
        "Color", "Message type", "Sent messages"
      }
    ) {
      Class[] types = new Class [] {
        java.lang.Object.class, java.lang.Long.class, java.lang.Long.class
      };
      boolean[] canEdit = new boolean [] {
        false, false, false
      };

      public Class getColumnClass(int columnIndex) {
        return types [columnIndex];
      }

      public boolean isCellEditable(int rowIndex, int columnIndex) {
        return canEdit [columnIndex];
      }
    });
    jTable1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jScrollPane1.setViewportView(jTable1);

    jTabbedPane1.addTab("Sent messages", jScrollPane1);

    jPanel10.add(jTabbedPane1, java.awt.BorderLayout.CENTER);
    jPanel10.add(jPanel11, java.awt.BorderLayout.PAGE_START);

    jPanel2.add(jPanel10, java.awt.BorderLayout.CENTER);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);
    getContentPane().add(jPanel7, java.awt.BorderLayout.PAGE_START);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-433)/2, (screenSize.height-350)/2, 433, 350);
  }// </editor-fold>//GEN-END:initComponents

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
  formWindowClosing(null);
}//GEN-LAST:event_jButton2ActionPerformed

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
  setVisible(false);
  dispose();
}//GEN-LAST:event_formWindowClosing
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.JButton jButton2;
  public javax.swing.JLabel jLabel1;
  public javax.swing.JLabel jLabel2;
  public javax.swing.JLabel jLabel3;
  public javax.swing.JLabel jLabel4;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel10;
  public javax.swing.JPanel jPanel11;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JPanel jPanel3;
  public javax.swing.JPanel jPanel4;
  public javax.swing.JPanel jPanel5;
  public javax.swing.JPanel jPanel6;
  public javax.swing.JPanel jPanel7;
  public javax.swing.JPanel jPanel8;
  public javax.swing.JPanel jPanel9;
  public javax.swing.JScrollPane jScrollPane1;
  public javax.swing.JScrollPane jScrollPane2;
  public javax.swing.JTabbedPane jTabbedPane1;
  public javax.swing.JTable jTable1;
  public javax.swing.JTable jTable2;
  // End of variables declaration//GEN-END:variables
  
}
