/*
 * SlidersDialog.java
 *
 * Created on Sobota, 2008, mj 3, 20:57
 */

package form.dialog;

import java.awt.Dimension;

/**
 *
 * @author  Dur
 */
public class SlidersDialog extends javax.swing.JDialog {
  protected boolean isOkClicked=false;
  protected int scrollCount=5;
  protected String[] names; 
  
  /** Creates new form SlidersDialog */
  public SlidersDialog(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
    names=new String[5];
    for (int i=0;i<names.length;i++)
    {
      names[i]="";
    }
  }
  
  public boolean IsOkClicked()
  {
    return isOkClicked;
  }
  
  public void SetSliderCount(int count)
  {
    scrollCount=count;
    Dimension dimension=getSize();
    dimension.height=30*count+80;
    setSize(dimension);
    jSlider1.setVisible(1<=count);
    jSlider2.setVisible(2<=count);
    jSlider3.setVisible(3<=count);
    jSlider6.setVisible(4<=count);
    jSlider7.setVisible(5<=count);
  }
  
  public void SetSlider(int index, String name, int defaultValue)
  {
    names[index]=name;
    switch (index)
    {
      case 0:
        jSlider1.setValue(defaultValue);
        break;
      case 1:
        jSlider2.setValue(defaultValue);
        break;
      case 2:
        jSlider3.setValue(defaultValue);
        break;
      case 3:
        jSlider6.setValue(defaultValue);
        break;
      case 4:
        jSlider7.setValue(defaultValue);
        break;
    }
  }
  
  public void SetSlider(int index, String name, int defaultValue, int maxValue)
  {
    switch (index)
    {
      case 0:
        jSlider1.setMaximum(maxValue);
        break;
      case 1:
        jSlider2.setMaximum(maxValue);
        break;
      case 2:
        jSlider3.setMaximum(maxValue);
        break;
      case 3:
        jSlider6.setMaximum(maxValue);
        break;
      case 4:
        jSlider7.setMaximum(maxValue);
        break;
    }
    SetSlider(index,name,defaultValue);
  }
  
  public int GetValue(int index)
  {
    switch (index)
    {
      case 0:
        return jSlider1.getValue();
      case 1:
        return jSlider2.getValue();
      case 2:
        return jSlider3.getValue();
      case 3:
        return jSlider6.getValue();
      case 4:
        return jSlider7.getValue();
    }
    return 0;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    jPanel1 = new javax.swing.JPanel();
    jButton1 = new javax.swing.JButton();
    jButton2 = new javax.swing.JButton();
    jPanel2 = new javax.swing.JPanel();
    jLabel1 = new javax.swing.JLabel();
    jSlider1 = new javax.swing.JSlider();
    jLabel2 = new javax.swing.JLabel();
    jSlider2 = new javax.swing.JSlider();
    jLabel3 = new javax.swing.JLabel();
    jSlider3 = new javax.swing.JSlider();
    jLabel4 = new javax.swing.JLabel();
    jSlider6 = new javax.swing.JSlider();
    jLabel5 = new javax.swing.JLabel();
    jSlider7 = new javax.swing.JSlider();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowOpened(java.awt.event.WindowEvent evt) {
        formWindowOpened(evt);
      }
    });

    jButton1.setText("OK");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });

    jPanel1.add(jButton1);

    jButton2.setText("Cancel");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });

    jPanel1.add(jButton2);

    getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

    jPanel2.setLayout(null);

    jLabel1.setText("jLabel1");
    jPanel2.add(jLabel1);
    jLabel1.setBounds(10, 20, 70, 14);

    jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(javax.swing.event.ChangeEvent evt) {
        jSlider1StateChanged(evt);
      }
    });

    jPanel2.add(jSlider1);
    jSlider1.setBounds(80, 10, 210, 25);

    jLabel2.setText("jLabel2");
    jPanel2.add(jLabel2);
    jLabel2.setBounds(10, 50, 70, 14);

    jSlider2.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(javax.swing.event.ChangeEvent evt) {
        jSlider2StateChanged(evt);
      }
    });

    jPanel2.add(jSlider2);
    jSlider2.setBounds(80, 40, 210, 25);

    jLabel3.setText("jLabel3");
    jPanel2.add(jLabel3);
    jLabel3.setBounds(10, 80, 70, 14);

    jSlider3.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(javax.swing.event.ChangeEvent evt) {
        jSlider3StateChanged(evt);
      }
    });

    jPanel2.add(jSlider3);
    jSlider3.setBounds(80, 70, 210, 25);

    jLabel4.setText("jLabel4");
    jPanel2.add(jLabel4);
    jLabel4.setBounds(10, 110, 70, 14);

    jSlider6.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(javax.swing.event.ChangeEvent evt) {
        jSlider6StateChanged(evt);
      }
    });

    jPanel2.add(jSlider6);
    jSlider6.setBounds(80, 100, 210, 25);

    jLabel5.setText("jLabel5");
    jPanel2.add(jLabel5);
    jLabel5.setBounds(10, 140, 70, 14);

    jSlider7.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(javax.swing.event.ChangeEvent evt) {
        jSlider7StateChanged(evt);
      }
    });

    jPanel2.add(jSlider7);
    jSlider7.setBounds(80, 130, 210, 25);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-294)/2, (screenSize.height-293)/2, 294, 293);
  }// </editor-fold>//GEN-END:initComponents

  private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
    jSlider1StateChanged(null);
    jSlider2StateChanged(null);
    jSlider3StateChanged(null);
    jSlider6StateChanged(null);
    jSlider7StateChanged(null);
  }//GEN-LAST:event_formWindowOpened

  private void jSlider7StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider7StateChanged
    jLabel5.setText(names[4]+"  "+Integer.toString(jSlider7.getValue()));
  }//GEN-LAST:event_jSlider7StateChanged

  private void jSlider6StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider6StateChanged
    jLabel4.setText(names[3]+"  "+Integer.toString(jSlider6.getValue()));
  }//GEN-LAST:event_jSlider6StateChanged

  private void jSlider3StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider3StateChanged
    jLabel3.setText(names[2]+"  "+Integer.toString(jSlider3.getValue()));
  }//GEN-LAST:event_jSlider3StateChanged

  private void jSlider2StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider2StateChanged
    jLabel2.setText(names[1]+"  "+Integer.toString(jSlider2.getValue()));
  }//GEN-LAST:event_jSlider2StateChanged

  private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider1StateChanged
    jLabel1.setText(names[0]+"  "+Integer.toString(jSlider1.getValue()));
  }//GEN-LAST:event_jSlider1StateChanged

  private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    setVisible(false);
  }//GEN-LAST:event_jButton2ActionPerformed

  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    isOkClicked=true;
    setVisible(false);
  }//GEN-LAST:event_jButton1ActionPerformed
  
  /**
   * @param args the command line arguments
   */
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.JButton jButton1;
  public javax.swing.JButton jButton2;
  public javax.swing.JLabel jLabel1;
  public javax.swing.JLabel jLabel2;
  public javax.swing.JLabel jLabel3;
  public javax.swing.JLabel jLabel4;
  public javax.swing.JLabel jLabel5;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JSlider jSlider1;
  public javax.swing.JSlider jSlider2;
  public javax.swing.JSlider jSlider3;
  public javax.swing.JSlider jSlider6;
  public javax.swing.JSlider jSlider7;
  // End of variables declaration//GEN-END:variables
  
}
