/*
 * ElectionNodeDialog.java
 *
 * Created on Nedea, 2008, mj 4, 23:36
 */

package form.dialog;

import graphics.StandardVisualizationData;
import java.awt.Color;
import java.util.Iterator;
import java.util.Map.Entry;
import javax.swing.JColorChooser;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;
import other.AssociativeArray;
import other.Functions;
import other.Global;
import other.IDialog;

/**
 *
 * @author  Dur
 */
public class StandardVisualizationDataDialog extends javax.swing.JDialog implements IDialog{
  protected boolean isOKPressed=false;
  protected StandardVisualizationData data;
  
  /**
   * Creates new form ElectionNodeDialog
   */
  public StandardVisualizationDataDialog(java.awt.Frame parent, boolean modal) {
    this(new StandardVisualizationData(),parent, modal);
  }
  
  public StandardVisualizationDataDialog(StandardVisualizationData data, java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    this.data=(StandardVisualizationData)data.clone();
    initComponents();
    
    jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() 
    {
      public void valueChanged(ListSelectionEvent e) {
        if (jTable1.getSelectedRow()==-1)
        {
          jButton4.setEnabled(false);
          jButton5.setEnabled(false);
        }
        else
        {
          jButton4.setEnabled(true);
          jButton5.setEnabled(true);
        }
      }
    });
    jTable2.getSelectionModel().addListSelectionListener(new ListSelectionListener() 
    {
      public void valueChanged(ListSelectionEvent e) {
        if (jTable2.getSelectedRow()==-1)
        {
          jButton7.setEnabled(false);
          jButton8.setEnabled(false);
        }
        else
        {
          jButton7.setEnabled(true);
          jButton8.setEnabled(true);
        }
      }
    });
    
    UpdateForm();
    getRootPane().setDefaultButton(jButton1);
  }
  
  public void UpdateForm()
  {
    try
    {
      jTextField3.setText(data.properties.get("name").toString());
      jTextField2.setText(data.properties.get("node_text").toString());
      jSpinner1.setValue(Functions.intVal(data.properties.get("node_width").toString()));
      jSpinner2.setValue(Functions.intVal(data.properties.get("node_height").toString()));
      if (data.properties.get("same_color")!=null)
        jTextField4.setText(data.properties.get("same_color").toString());
      
      String notVisual="";
      Iterator<Object> it0=data.notVisualizingMessageTypes.values().iterator();
      while (it0.hasNext())
      {
        Object o=it0.next();
        if (o!=null)
          notVisual+=o.toString()+", ";
      }
      if (notVisual.length()>2)
        notVisual=notVisual.substring(0, notVisual.length()-2);
      jTextField1.setText(notVisual);
      
      DefaultTableModel model=(DefaultTableModel)jTable1.getModel();
      model.setNumRows(0);
      Iterator<Entry<Integer, Color>> it=data.messageTypesBgColors.entrySet().iterator();
      while (it.hasNext())
      {
        Entry<Integer, Color> e=it.next();
        Object[] o=new Object[2];
        o[0]=e.getKey();
        o[1]="<html><body style=\"background-color: rgb("+e.getValue().getRed()+", "+e.getValue().getGreen()+", "+e.getValue().getBlue()+");\"><div style=\"width: 200px;\">&nbsp;</div></body></html>";
        model.addRow(o);
      }
      
      model=(DefaultTableModel)jTable2.getModel();
      model.setNumRows(0); 
      Iterator<AssociativeArray<Object, Object>> it2=data.nodeBgColors.iterator();
      while (it2.hasNext())
      {
        AssociativeArray<Object, Object> e=it2.next();
        Object[] o=new Object[3];
        o[0]=e.get("property");
        o[1]=e.get("equals_to");
        o[2]="<html><body style=\"background-color: rgb("+((Color)e.get("color")).getRed()+", "+((Color)e.get("color")).getGreen()+", "+((Color)e.get("color")).getBlue()+");\"><div style=\"width: 200px;\">&nbsp;</div></body></html>";
        model.addRow(o);
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->StandardVisualizationDataDialog->UpdateForm",e);
    }
  }
  
  public void UpdateData()
  {
    try
    {
      if (data!=null)
      {
        data.properties.put("name", jTextField3.getText());
        data.properties.put("node_text", jTextField2.getText());
        data.properties.put("node_width", jSpinner1.getValue().toString());
        data.properties.put("node_height", jSpinner2.getValue().toString());
        data.properties.put("same_color", jTextField4.getText());
        String text=jTextField1.getText();
        text=text.replaceAll(", ", ",");
        String[] types=Functions.Explode(",", text);
        data.notVisualizingMessageTypes.clear();
        for (int i=0;i<types.length;i++)
        {
          Integer type=new Integer(Functions.intVal(types[i]));
          data.notVisualizingMessageTypes.put(type, type);
        }
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->StandardVisualizationDataDialog->UpdateNode",e);
    }
  }
  
  public boolean IsOKPressed()
  {
    return isOKPressed;
  }
  
  public StandardVisualizationData GetVisualizationData()
  {
    return data;
  }
  
  @Override
  public void setVisible(boolean b)
  {
    super.setVisible(b);
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPopupMenu1 = new javax.swing.JPopupMenu();
    jMenuItem1 = new javax.swing.JMenuItem();
    jMenuItem2 = new javax.swing.JMenuItem();
    jMenuItem3 = new javax.swing.JMenuItem();
    jPanel1 = new javax.swing.JPanel();
    jButton1 = new javax.swing.JButton();
    jButton2 = new javax.swing.JButton();
    jPanel8 = new javax.swing.JPanel();
    jPanel6 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    jLabel3 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();
    jLabel4 = new javax.swing.JLabel();
    jLabel5 = new javax.swing.JLabel();
    jLabel6 = new javax.swing.JLabel();
    jLabel1 = new javax.swing.JLabel();
    jPanel5 = new javax.swing.JPanel();
    jTextField3 = new javax.swing.JTextField();
    jTextField2 = new javax.swing.JTextField();
    jSpinner1 = new javax.swing.JSpinner();
    jSpinner2 = new javax.swing.JSpinner();
    jTextField4 = new javax.swing.JTextField();
    jTextField1 = new javax.swing.JTextField();
    jPanel9 = new javax.swing.JPanel();
    jPanel10 = new javax.swing.JPanel();
    jTabbedPane1 = new javax.swing.JTabbedPane();
    jPanel14 = new javax.swing.JPanel();
    jPanel15 = new javax.swing.JPanel();
    jButton6 = new javax.swing.JButton();
    jButton7 = new javax.swing.JButton();
    jButton8 = new javax.swing.JButton();
    jScrollPane2 = new javax.swing.JScrollPane();
    jTable2 = new javax.swing.JTable();
    jPanel12 = new javax.swing.JPanel();
    jPanel13 = new javax.swing.JPanel();
    jButton3 = new javax.swing.JButton();
    jButton4 = new javax.swing.JButton();
    jButton5 = new javax.swing.JButton();
    jScrollPane1 = new javax.swing.JScrollPane();
    jTable1 = new javax.swing.JTable();
    jPanel7 = new javax.swing.JPanel();

    jPopupMenu1.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
      public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
      }
      public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
      }
      public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
        jPopupMenu1PopupMenuWillBecomeVisible(evt);
      }
    });

    jMenuItem1.setText("New color");
    jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem1ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem1);

    jMenuItem2.setText("Edit color");
    jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem2ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem2);

    jMenuItem3.setText("Delete color");
    jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jMenuItem3ActionPerformed(evt);
      }
    });
    jPopupMenu1.add(jMenuItem3);

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Visualization properties");
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
    });

    jButton1.setText("OK");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton1);

    jButton2.setText("Cancel");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton2);

    getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);
    getContentPane().add(jPanel8, java.awt.BorderLayout.LINE_END);
    getContentPane().add(jPanel6, java.awt.BorderLayout.WEST);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel3.setLayout(new java.awt.BorderLayout());

    jPanel4.setLayout(new java.awt.GridLayout(0, 1, 0, 3));

    jLabel3.setText("Name: ");
    jPanel4.add(jLabel3);

    jLabel2.setText("Node text: ");
    jPanel4.add(jLabel2);

    jLabel4.setText("Node width: ");
    jPanel4.add(jLabel4);

    jLabel5.setText("Node height: ");
    jPanel4.add(jLabel5);

    jLabel6.setText("Generate node color from property: ");
    jPanel4.add(jLabel6);

    jLabel1.setText("Do not visualize these message types: ");
    jPanel4.add(jLabel1);

    jPanel3.add(jPanel4, java.awt.BorderLayout.WEST);

    jPanel5.setLayout(new java.awt.GridLayout(0, 1, 0, 3));

    jTextField3.setText("new_name");
    jPanel5.add(jTextField3);

    jTextField2.setText("id");
    jPanel5.add(jTextField2);

    jSpinner1.setPreferredSize(new java.awt.Dimension(25, 20));
    jPanel5.add(jSpinner1);

    jSpinner2.setPreferredSize(new java.awt.Dimension(25, 20));
    jPanel5.add(jSpinner2);
    jPanel5.add(jTextField4);
    jPanel5.add(jTextField1);

    jPanel3.add(jPanel5, java.awt.BorderLayout.CENTER);

    jPanel2.add(jPanel3, java.awt.BorderLayout.PAGE_START);

    jPanel9.setLayout(new java.awt.BorderLayout());
    jPanel9.add(jPanel10, java.awt.BorderLayout.PAGE_START);

    jPanel14.setLayout(new java.awt.BorderLayout());

    jButton6.setText("New color");
    jButton6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton6ActionPerformed(evt);
      }
    });
    jPanel15.add(jButton6);

    jButton7.setText("Edit color");
    jButton7.setEnabled(false);
    jButton7.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton7ActionPerformed(evt);
      }
    });
    jPanel15.add(jButton7);

    jButton8.setText("Delete color");
    jButton8.setEnabled(false);
    jButton8.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton8ActionPerformed(evt);
      }
    });
    jPanel15.add(jButton8);

    jPanel14.add(jPanel15, java.awt.BorderLayout.PAGE_END);

    jTable2.setModel(new javax.swing.table.DefaultTableModel(
      new Object [][] {

      },
      new String [] {
        "Property", "Equals to", "Color"
      }
    ) {
      boolean[] canEdit = new boolean [] {
        false, false, false
      };

      public boolean isCellEditable(int rowIndex, int columnIndex) {
        return canEdit [columnIndex];
      }
    });
    jTable2.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jTable2.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        jTable2MouseClicked(evt);
      }
      public void mouseReleased(java.awt.event.MouseEvent evt) {
        jTable2MouseReleased(evt);
      }
    });
    jScrollPane2.setViewportView(jTable2);

    jPanel14.add(jScrollPane2, java.awt.BorderLayout.CENTER);

    jTabbedPane1.addTab("Node colors", jPanel14);

    jPanel12.setLayout(new java.awt.BorderLayout());

    jButton3.setText("New color");
    jButton3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton3ActionPerformed(evt);
      }
    });
    jPanel13.add(jButton3);

    jButton4.setText("Edit color");
    jButton4.setEnabled(false);
    jButton4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton4ActionPerformed(evt);
      }
    });
    jPanel13.add(jButton4);

    jButton5.setText("Delete color");
    jButton5.setEnabled(false);
    jButton5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton5ActionPerformed(evt);
      }
    });
    jPanel13.add(jButton5);

    jPanel12.add(jPanel13, java.awt.BorderLayout.PAGE_END);

    jTable1.setModel(new javax.swing.table.DefaultTableModel(
      new Object [][] {

      },
      new String [] {
        "Message type", "Color"
      }
    ) {
      boolean[] canEdit = new boolean [] {
        false, false
      };

      public boolean isCellEditable(int rowIndex, int columnIndex) {
        return canEdit [columnIndex];
      }
    });
    jTable1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        jTable1MouseClicked(evt);
      }
      public void mouseReleased(java.awt.event.MouseEvent evt) {
        jTable1MouseReleased(evt);
      }
    });
    jScrollPane1.setViewportView(jTable1);

    jPanel12.add(jScrollPane1, java.awt.BorderLayout.CENTER);

    jTabbedPane1.addTab("Message colors", jPanel12);

    jPanel9.add(jTabbedPane1, java.awt.BorderLayout.CENTER);

    jPanel2.add(jPanel9, java.awt.BorderLayout.CENTER);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);
    getContentPane().add(jPanel7, java.awt.BorderLayout.PAGE_START);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-522)/2, (screenSize.height-459)/2, 522, 459);
  }// </editor-fold>//GEN-END:initComponents

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
  formWindowClosing(null);
}//GEN-LAST:event_jButton2ActionPerformed

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
  setVisible(false);
  dispose();
}//GEN-LAST:event_formWindowClosing

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
  isOKPressed=true;
  UpdateData();
  formWindowClosing(null);
}//GEN-LAST:event_jButton1ActionPerformed

private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
  try
  {
    Color c=JColorChooser.showDialog(this, "Choose color", Color.WHITE);
    if (c!=null)
    {
      String type=JOptionPane.showInputDialog(this, "Message type", "0");
      if (type!=null)
      {
        UpdateData();
        data.messageTypesBgColors.put(Functions.intVal(type), c);
        UpdateForm();
      }
    }
  }
  catch (Exception e)
  {
    Global.errorLog.Write("form->dialog->StandardVisualizationDataDialog->jButton3ActionPerformed",e);
  }
}//GEN-LAST:event_jButton3ActionPerformed

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
  try
  {
    int index=jTable1.getSelectedRow();
    Color c=JColorChooser.showDialog(this, "Choose color", data.messageTypesBgColors.get(jTable1.getModel().getValueAt(index, 0)));
    if (c!=null)
    {
      UpdateData();
      data.messageTypesBgColors.put(Functions.intVal(jTable1.getModel().getValueAt(index, 0).toString()), c);
      UpdateForm();
    }
  }
  catch (Exception e)
  {
    Global.errorLog.Write("form->dialog->StandardVisualizationDataDialog->jButton4ActionPerformed",e);
  }
}//GEN-LAST:event_jButton4ActionPerformed

private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
  try
  {
    int index=jTable1.getSelectedRow();
    UpdateData();
    data.messageTypesBgColors.remove(jTable1.getModel().getValueAt(index, 0));
    UpdateForm();
  }
  catch (Exception e)
  {
    Global.errorLog.Write("form->dialog->StandardVisualizationDataDialog->jButton5ActionPerformed",e);
  }
}//GEN-LAST:event_jButton5ActionPerformed

private void jTable1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseClicked
if ((evt!=null) && (evt.getClickCount()>1))
  {
    jButton4ActionPerformed(null);
  }
}//GEN-LAST:event_jTable1MouseClicked

private void jTable1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseReleased
  if ((evt!=null) && (evt.isPopupTrigger()))
  {
    jPopupMenu1.show(jTable1, evt.getX(), evt.getY());
  }
}//GEN-LAST:event_jTable1MouseReleased

private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
  if (jTabbedPane1.getSelectedIndex()==0)
    jButton6ActionPerformed(null);
  else
    jButton3ActionPerformed(null);
}//GEN-LAST:event_jMenuItem1ActionPerformed

private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
  if (jTabbedPane1.getSelectedIndex()==0)
    jButton7ActionPerformed(null);
  else
    jButton4ActionPerformed(null);
}//GEN-LAST:event_jMenuItem2ActionPerformed

private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
  if (jTabbedPane1.getSelectedIndex()==0)
    jButton8ActionPerformed(null);
  else
    jButton5ActionPerformed(null);
}//GEN-LAST:event_jMenuItem3ActionPerformed

private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
  try
  {
    Color c=JColorChooser.showDialog(this, "Choose color", Color.WHITE);
    if (c!=null)
    {
      String prop=JOptionPane.showInputDialog(this, "Property", "id");
      if (prop!=null)
      {
        String equalsTo=JOptionPane.showInputDialog(this, "Equals to", "0");
        if (equalsTo!=null)
        {
          UpdateData();
          AssociativeArray<Object, Object> o=new AssociativeArray<Object, Object>();
          o.put("property", prop);
          o.put("equals_to", equalsTo);
          o.put("color", c);
          data.nodeBgColors.add(o);
          UpdateForm();
        } 
      }
    }
  }
  catch (Exception e)
  {
    Global.errorLog.Write("form->dialog->StandardVisualizationDataDialog->jButton6ActionPerformed",e);
  }
}//GEN-LAST:event_jButton6ActionPerformed

private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
  try
  {
    int index=jTable2.getSelectedRow();
    Color c=JColorChooser.showDialog(this, "Choose color", (Color)data.nodeBgColors.get(index).get("color"));
    if (c!=null)
    {
      UpdateData();
      data.nodeBgColors.get(jTable2.getSelectedRow()).put("color", c);
      UpdateForm();
    }
  }
  catch (Exception e)
  {
    Global.errorLog.Write("form->dialog->StandardVisualizationDataDialog->jButton7ActionPerformed",e);
  }
}//GEN-LAST:event_jButton7ActionPerformed

private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
  try
  {
    UpdateData();
    data.nodeBgColors.remove(jTable2.getSelectedRow());
    UpdateForm();
  }
  catch (Exception e)
  {
    Global.errorLog.Write("form->dialog->StandardVisualizationDataDialog->jButton8ActionPerformed",e);
  }
}//GEN-LAST:event_jButton8ActionPerformed

private void jTable2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable2MouseClicked
  if ((evt!=null) && (evt.getClickCount()>1) && (jTable2.getSelectedRow()>-1))
  {
    jButton7ActionPerformed(null);
  }
}//GEN-LAST:event_jTable2MouseClicked

private void jTable2MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable2MouseReleased
  if ((evt!=null) && (evt.isPopupTrigger()))
  {
    jPopupMenu1.show(jTable2, evt.getX(), evt.getY());
  }
}//GEN-LAST:event_jTable2MouseReleased

private void jPopupMenu1PopupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_jPopupMenu1PopupMenuWillBecomeVisible
  if (jTabbedPane1.getSelectedIndex()==0)
  {
    jMenuItem2.setEnabled(jTable2.getSelectedRow()>-1);
    jMenuItem3.setEnabled(jTable2.getSelectedRow()>-1);
  }
  else
  {
    jMenuItem2.setEnabled(jTable1.getSelectedRow()>-1);
    jMenuItem3.setEnabled(jTable1.getSelectedRow()>-1);
  }
}//GEN-LAST:event_jPopupMenu1PopupMenuWillBecomeVisible
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.JButton jButton1;
  public javax.swing.JButton jButton2;
  public javax.swing.JButton jButton3;
  public javax.swing.JButton jButton4;
  public javax.swing.JButton jButton5;
  public javax.swing.JButton jButton6;
  public javax.swing.JButton jButton7;
  public javax.swing.JButton jButton8;
  public javax.swing.JLabel jLabel1;
  public javax.swing.JLabel jLabel2;
  public javax.swing.JLabel jLabel3;
  public javax.swing.JLabel jLabel4;
  public javax.swing.JLabel jLabel5;
  public javax.swing.JLabel jLabel6;
  public javax.swing.JMenuItem jMenuItem1;
  public javax.swing.JMenuItem jMenuItem2;
  public javax.swing.JMenuItem jMenuItem3;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel10;
  public javax.swing.JPanel jPanel12;
  public javax.swing.JPanel jPanel13;
  public javax.swing.JPanel jPanel14;
  public javax.swing.JPanel jPanel15;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JPanel jPanel3;
  public javax.swing.JPanel jPanel4;
  public javax.swing.JPanel jPanel5;
  public javax.swing.JPanel jPanel6;
  public javax.swing.JPanel jPanel7;
  public javax.swing.JPanel jPanel8;
  public javax.swing.JPanel jPanel9;
  public javax.swing.JPopupMenu jPopupMenu1;
  public javax.swing.JScrollPane jScrollPane1;
  public javax.swing.JScrollPane jScrollPane2;
  public javax.swing.JSpinner jSpinner1;
  public javax.swing.JSpinner jSpinner2;
  public javax.swing.JTabbedPane jTabbedPane1;
  public javax.swing.JTable jTable1;
  public javax.swing.JTable jTable2;
  public javax.swing.JTextField jTextField1;
  public javax.swing.JTextField jTextField2;
  public javax.swing.JTextField jTextField3;
  public javax.swing.JTextField jTextField4;
  // End of variables declaration//GEN-END:variables
  
}
