/*
 * ElectionNodeDialog.java
 *
 * Created on Nedea, 2008, mj 4, 23:36
 */

package form.dialog;

import java.awt.Color;
import java.util.TreeMap;
import javax.swing.table.DefaultTableModel;
import network.NetworkConstraint;
import other.Global;
import player.Player;

/**
 *
 * @author  Dur
 */
public class StatisticsDialog extends javax.swing.JDialog {
  protected Player player;
  /**
   * Creates new form ElectionNodeDialog
   */
  public StatisticsDialog(Player player, java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
    getRootPane().setDefaultButton(jButton2);
    this.player=player;
    UpdateForm();
  }
  
  public void UpdateForm()
  {
    try
    {
      jLabel1.setText(new Integer(NetworkConstraint.numSentMessages).toString());
      jLabel4.setText(new Integer(NetworkConstraint.numActualMessages).toString());
      DefaultTableModel model=(DefaultTableModel) jTable1.getModel();
      model.setNumRows(0);
      Integer[] types=NetworkConstraint.GetSentMessageTypes();
      if (types!=null)
      {
        TreeMap<Integer, Color> colors=player.network.GetAlgorithm().GetActivatedVisualizationData().messageTypesBgColors;
        for (int i=0;i<types.length;i++)
        {
          Object[] o=new Object[]{"",types[i],NetworkConstraint.GetSentMessageCount(types[i]),NetworkConstraint.GetActualMessageCount(types[i])};
          Color c=colors.get(types[i]);
          if (c!=null)
            o[0]="<html><body style=\"background-color: rgb("+c.getRed()+", "+c.getGreen()+", "+c.getBlue()+");\"><div style=\"width: 200px;\">&nbsp;</div></body></html>";
          model.addRow(o);
        }
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("form->dialog->StatisticsDialog->UpdateForm",e);
    }
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPanel1 = new javax.swing.JPanel();
    jButton2 = new javax.swing.JButton();
    jPanel8 = new javax.swing.JPanel();
    jPanel6 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    jLabel2 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();
    jPanel5 = new javax.swing.JPanel();
    jLabel1 = new javax.swing.JLabel();
    jLabel4 = new javax.swing.JLabel();
    jPanel10 = new javax.swing.JPanel();
    jPanel11 = new javax.swing.JPanel();
    jScrollPane1 = new javax.swing.JScrollPane();
    jTable1 = new javax.swing.JTable();
    jPanel7 = new javax.swing.JPanel();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Statistics");
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        formWindowClosing(evt);
      }
    });

    jButton2.setText("Close");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });
    jPanel1.add(jButton2);

    getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);
    getContentPane().add(jPanel8, java.awt.BorderLayout.LINE_END);
    getContentPane().add(jPanel6, java.awt.BorderLayout.WEST);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel3.setLayout(new java.awt.BorderLayout());

    jPanel4.setLayout(new java.awt.GridLayout(0, 1, 0, 3));

    jLabel2.setText("Total number of sent messages: ");
    jPanel4.add(jLabel2);

    jLabel3.setText("Number of actually sending messages: ");
    jPanel4.add(jLabel3);

    jPanel3.add(jPanel4, java.awt.BorderLayout.WEST);

    jPanel5.setLayout(new java.awt.GridLayout(0, 1, 0, 3));

    jLabel1.setText("0");
    jPanel5.add(jLabel1);

    jLabel4.setText("0");
    jPanel5.add(jLabel4);

    jPanel3.add(jPanel5, java.awt.BorderLayout.CENTER);

    jPanel2.add(jPanel3, java.awt.BorderLayout.PAGE_START);

    jPanel10.setLayout(new java.awt.BorderLayout());
    jPanel10.add(jPanel11, java.awt.BorderLayout.PAGE_START);

    jTable1.setModel(new javax.swing.table.DefaultTableModel(
      new Object [][] {

      },
      new String [] {
        "Color", "Message type", "Sent messages", "Actually sending"
      }
    ) {
      Class[] types = new Class [] {
        java.lang.Object.class, java.lang.Long.class, java.lang.Long.class, java.lang.Long.class
      };
      boolean[] canEdit = new boolean [] {
        false, false, false, false
      };

      public Class getColumnClass(int columnIndex) {
        return types [columnIndex];
      }

      public boolean isCellEditable(int rowIndex, int columnIndex) {
        return canEdit [columnIndex];
      }
    });
    jTable1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jScrollPane1.setViewportView(jTable1);

    jPanel10.add(jScrollPane1, java.awt.BorderLayout.CENTER);

    jPanel2.add(jPanel10, java.awt.BorderLayout.CENTER);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);
    getContentPane().add(jPanel7, java.awt.BorderLayout.PAGE_START);

    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-433)/2, (screenSize.height-350)/2, 433, 350);
  }// </editor-fold>//GEN-END:initComponents

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
  formWindowClosing(null);
}//GEN-LAST:event_jButton2ActionPerformed

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
  setVisible(false);
  dispose();
}//GEN-LAST:event_formWindowClosing
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public javax.swing.JButton jButton2;
  public javax.swing.JLabel jLabel1;
  public javax.swing.JLabel jLabel2;
  public javax.swing.JLabel jLabel3;
  public javax.swing.JLabel jLabel4;
  public javax.swing.JPanel jPanel1;
  public javax.swing.JPanel jPanel10;
  public javax.swing.JPanel jPanel11;
  public javax.swing.JPanel jPanel2;
  public javax.swing.JPanel jPanel3;
  public javax.swing.JPanel jPanel4;
  public javax.swing.JPanel jPanel5;
  public javax.swing.JPanel jPanel6;
  public javax.swing.JPanel jPanel7;
  public javax.swing.JPanel jPanel8;
  public javax.swing.JScrollPane jScrollPane1;
  public javax.swing.JTable jTable1;
  // End of variables declaration//GEN-END:variables
  
}
