/*
 * Graphics.java
 *
 * Created on Utorok, 2008, aprl 1, 18:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package graphics;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Stroke;
import java.awt.geom.Ellipse2D;
import java.io.Serializable;

/**
 *
 * @author Dur
 */
public class Graphics implements Serializable
{
  protected Color color,textColor,fillColor;
  protected transient java.awt.Graphics2D g2d;
  protected int charWidth=7;
  protected int charHeight=10;
  
  /** Creates a new instance of Graphics */
  public Graphics() {
    color=Color.RED;
    textColor=Color.BLACK;
    fillColor=Color.WHITE;
  }
  
  public void Clear()
  {
    g2d.drawRect(-1,-1,g2d.getClipBounds().width+1,g2d.getClipBounds().height+1);
  }
  
  public void DrawString(Point position, String text)
  {
    g2d.setPaint(textColor);
    g2d.drawString(text,position.x,position.y);
  }
  
  public void DrawLabelledEllipse(Point position,Point dimension,String text)
  {
    DrawLabelledEllipse(position,dimension);
    int l=text.length();
    Point p=new Point(position.x, position.y);
    p.x=p.x-(l*charWidth)/2;
    p.y=p.y+(charHeight/2);
    DrawString(p, text);
  }
  
  public void DrawLabelledEllipse(Point position,Point dimension)
  {
    Ellipse2D.Float oval=new Ellipse2D.Float(position.x-dimension.x/2,position.y-dimension.y/2,dimension.x,dimension.y);
    g2d.setPaint(fillColor);
    g2d.fill(oval);
    g2d.setPaint(color);
    g2d.draw(oval);
  }
  
  public void DrawLabelledLine(Point p1,Point p2)
  {
    g2d.setPaint(color);
    g2d.drawLine(p1.x,p1.y,p2.x,p2.y);
  }
  
  public void DrawLabelledLine(Point p1,Point p2,String text)
  {
    DrawLabelledLine(p1,p2);
  }
  
  public void SetColor(Color color)
  {
    this.color=color;
  }
  
  public Color GetColor()
  {
    return color;
  }
  
  public void SetTextColor(Color color)
  {
    this.textColor=color;
  }
  
  public Color GetTextColor()
  {
    return textColor;
  }
  
  public void SetFillColor(Color color)
  {
    this.fillColor=color;
  }
  
  public Color GetFillColor()
  {
    return fillColor;
  }
  
  public void SetGraphics(java.awt.Graphics graphics)
  {
    this.g2d=(Graphics2D) graphics;
  }
  
  public java.awt.Graphics GetGraphics()
  {
    return g2d;
  }
  
  public void SetStroke(Stroke stroke)
  {
    g2d.setStroke(stroke);
  }
  
}
