/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package network;

import java.io.Serializable;
import player.Player;

/**
 *
 * @author Dur
 */
public abstract class Constraint implements Serializable
{
  protected Player player;
  
  public static void Initialize(Player player)
  {
    NetworkConstraint.Initialize(player);
  }
  
  //called when Node sends message
  public static void SentMessage(LinkMessage mes)
  {
    NetworkConstraint.SentMessage(mes);
  }
  
  //called when Node receives message
  public static void ReceivedMessage(LinkMessage mes)
  {
    NetworkConstraint.ReceivedMessage(mes);
  }
  
  //called if message cannot pass through link, for example: corrupted link
  public static void DestroyedMessage(LinkMessage mes)
  {
    NetworkConstraint.DestroyedMessage(mes);
  }
  
  public void RunBeforeVisualization(Player player)
  {
    this.player=player;
  }
  
  public abstract boolean IsSatisfied(LinkMessage mes);
  
}
