/*
 * Node.java
 *
 * Created on Utorok, 2008, aprl 1, 10:42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package network;

import form.dialog.NodeDialog;
import java.awt.Frame;
import java.awt.Point;
import java.io.Serializable;
import java.util.Random;
import other.AssociativeArray;
import other.Functions;
import other.IDialog;
import player.Player;
import thread.NodeThread;

/**
 *
 * @author Dur
 */
public class Node implements Serializable
{
  public Network network;
  public Link[] links;
  public Point position, dimension;
  public AssociativeArray<Object,Object> prop=new AssociativeArray<Object, Object>();
  public transient NodeThread nodeThread;
  
  /** Creates a new instance of Node */
  public Node(Network network) 
  {
    this.network=network;
    position=new Point(0,0);
    dimension=network.GetAlgorithm().GetActivatedVisualizationData().GetNodeDimension();
    links=new Link[0];
    prop.put("id", new Integer(network.NextFreeNodeId()).toString());
  }
  
  public void AddLink(Link link)
  {
    Link[] l=new Link[links.length+1];
    System.arraycopy(links,0,l,0,links.length);
    l[l.length-1]=link;
    links=l;
  }
  
  public int GetLinkId(Link link)
  {
    for (int i=0;i<links.length;i++)
    {
      if (link==links[i])
      {
        return i;
      }
    }
    return -1;
  }
  
  public void DeleteLink(int index)
  {
    Link[] l=new Link[links.length-1];
    if ((index>=0) && (index<links.length))
    {
      if (index>0) System.arraycopy(links,0,l,0,index);
      if (index<(links.length-1)) System.arraycopy(links,index+1,l,index,links.length-index-1);
      links=l;
    }
  }
  
  public void DeleteLink(Link link)
  {
    for (int i=0;i<links.length;i++)
    {
      if (links[i]==link) DeleteLink(i);
    }
  }
  
  public IDialog CreatePropertiesDialog(Frame parent, boolean modal)
  {
    return new NodeDialog(this,parent,modal,false);
  }
  
  public boolean IsAtPosition(Point p)
  {
    if (p.x>=(position.x-dimension.x/2) && (p.x<=position.x+dimension.x/2))
    {
      if (p.y>=(position.y-dimension.y/2) && (p.y<=position.y+dimension.y/2)) 
        return true;
    }
    return false;
  }
  
  public void SetPosition(Point p)
  {
    position=p;
  }
  
  public void SetDimension(Point p)
  {
    dimension=p;
  }
  
  public void PrepareForVisualization(Player player)
  {
    nodeThread=new NodeThread(this,player);
  }
  
  public void ShuffleLinks()
  {
    Random rnd=new Random();
    for (int i=0;i<links.length;i++)
    {
      int pos1=rnd.nextInt(links.length);
      int pos2=rnd.nextInt(links.length);
      Link l=links[pos1];
      links[pos1]=links[pos2];
      links[pos2]=l;
    }
  }
  
  @Override
  public int hashCode() {
    return Functions.intVal(prop.get("id").toString());
  }

  @Override
  public boolean equals(Object obj) {
    if (obj == null) {
      return false;
    }
    if (getClass() != obj.getClass()) {
      return false;
    }
    final Node other = (Node) obj;
    try
    {
      if (!prop.get("id").equals(other.prop.get("id"))) 
      {
        return false;
      }
      return true;
    }
    catch (Exception e){}
    return false;
  }
  
}
