/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package network;

import player.Player;

/**
 *
 * @author Dur
 */
public class NodeConstraint extends Constraint
{
  
  public Integer messageNum=null;
  public Integer messageType=null;
  public Integer currentMessageType=null;
  public Integer nodeId=null;
  public int currentMessageOperator=0;
  public int currentMessageCount=0;
  
  @Override
  public void RunBeforeVisualization(Player player)
  {
    super.RunBeforeVisualization(player);
  }
  
  @Override
  public boolean IsSatisfied(LinkMessage mes)
  {
    if (mes!=null)
    {
      if ((messageType!=null) && (!messageType.equals(mes.message.GetType())))
      {
        //if message type is different from message type bound by constraint
        return true;
      }
      
      //find out whether serial number of message corresponds
      if (messageNum!=null)
      {
        Integer sn=0;
        if (messageType==null)
        {
          synchronized (NetworkConstraint.numSentMessagesByNode)
          {
            sn=NetworkConstraint.numSentMessagesByNode[mes.sender.network.GetNodeIndex(mes.sender)];
          }
        }
        else
        {
          synchronized (NetworkConstraint.numSentMessagesOfTypeByNode)
          {
            sn=NetworkConstraint.numSentMessagesOfTypeByNode[mes.sender.network.GetNodeIndex(mes.sender)].get(mes.message.GetType());
          }
        }
        if ((messageNum!=null) && (!messageNum.equals(sn)))
        {
          //if serial number of message differs from constraint serial number
          return true;
        }
      }
       
      int currentMessageCount2=0;
      boolean outOfBounds=false;
      if (currentMessageType==null)
      {
        if (nodeId==null)
        {
          currentMessageCount2=NetworkConstraint.numSentMessages;
        }
        else
        {
          int nodeIndex=mes.sender.network.GetNodeIndex(mes.sender.network.GetNodeById(nodeId));
          if ((nodeIndex>=0) && (nodeIndex<mes.sender.network.nodes.length))
          {
            synchronized (NetworkConstraint.numSentMessagesByNode)
            {
              currentMessageCount2=NetworkConstraint.numSentMessagesByNode[nodeIndex];
            }
          }
          else
            outOfBounds=true;
        }
      }
      else
      {
        if (nodeId==null)
        {
          synchronized (NetworkConstraint.numSentMessagesOfType)
          {
            Integer count=NetworkConstraint.numSentMessagesOfType.get(currentMessageType);
            if (count!=null)
              currentMessageCount2=count;
          }
        }
        else
        {
          int nodeIndex=mes.sender.network.GetNodeIndex(mes.sender.network.GetNodeById(nodeId));
          if ((nodeIndex>=0) && (nodeIndex<mes.sender.network.nodes.length))
          {
            synchronized (NetworkConstraint.numSentMessagesOfTypeByNode)
            {
              Integer count=NetworkConstraint.numSentMessagesOfTypeByNode[nodeIndex].get(currentMessageType);
              if (count!=null)
                currentMessageCount2=count;
            }
          }
          else
            outOfBounds=true;
        }
      }
      if (outOfBounds)
        return true;
      switch (currentMessageOperator)
      {
        case 0: 
          return currentMessageCount2<currentMessageCount;
        case 1: 
          return currentMessageCount2<=currentMessageCount;
        case 2: 
          return currentMessageCount2==currentMessageCount;
        case 3: 
          return currentMessageCount2>=currentMessageCount;
        case 4: 
          return currentMessageCount2>currentMessageCount;
      }
    }
    return true;
  }
  
}
