/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package other;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.HashMap;

/**
 *
 * @author Džuráč
 */
public class FileClassLoader extends ClassLoader{
  private File filename=null;
  private Class mainClazz=null;
  private byte[] fileContent=new byte[0];
  private boolean isFileOk=true;
  private String className=null;
  private HashMap<String, Class> allClasses=new HashMap<String, Class>();
  
  public FileClassLoader(File filename, String className)
  {
    try
    {
      this.filename=filename;
      this.className=className;
      LoadClassesFromDirectory(new File(Configuration.temporaryDir));
      mainClazz=allClasses.get(filename.getName().replaceAll(".class", ""));
      if (mainClazz==null)
        isFileOk=false;
    }
    catch (Exception e)
    {
      isFileOk=false;
    }
  }
  
  private void LoadClassesFromDirectory(File directory)
  {
    File[] files=directory.listFiles();
    for (int i=0;i<files.length;i++)
    {
      if (files[i].isFile())
      {
        if (files[i].getName().indexOf(".class")>-1)
        {
          LoadClass(files[i]);
        }
      }
    }
  }
  
  private void LoadClass(File filename)
  {
    try
    {
      InputStream inputStream= new FileInputStream(filename);
      int fileSize = (int) filename.length();
      fileContent = new byte[fileSize];
      inputStream.read(fileContent, 0, fileSize);
      allClasses.put(filename.getName().replaceAll(".class", ""), defineClass(filename.getName().replaceAll(".class", ""), fileContent, 0, fileContent.length));
    }
    catch (Exception e)
    {
      isFileOk=false;
    }
  }
  
  @Override
  public Class findClass(String name) 
  {
    return allClasses.get(name);
  }

  
  public boolean IsFileOk()
  {
    return isFileOk;
  }
  
  public Object GetNewInstance() throws Exception
  {
    if (filename!=null)
    {
      return mainClazz.newInstance();
    }
    return null;
  }
  
}
