/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package other;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.DecimalFormat;
import java.util.LinkedList;

/**
 *
 * @author Dur
 */
public class Functions {
  protected static String point=null;
  protected static String notWordDelimiters="0123456789abcdefghijklmnopqrstuvxyzABCDEFGHIJKLMNOPQRSTUVXYZ";
  
  public static int intVal(String s)
  {
    return intValDef(s, 0);
  }
  
  public static int intValDef(String s, int defaultValue)
  {
    try
    {
      return Integer.valueOf(s);
    }
    catch (Exception e){}
    return defaultValue;
  }
  
  public static Double DoubleVal(String s)
  {
    return DoubleValDef(s, 0);
  }
  
  public static Double DoubleValDef(String s, double defaultValue)
  {
    try
    {
      s=StringToDoubleString(s);
      return Double.valueOf(s);
    }
    catch (Exception e){}
    return Double.valueOf(defaultValue);
  }
  
  public static Boolean BooleanVal(String s)
  {
    return BooleanValDef(s, false);
  }
  
  public static Boolean BooleanValDef(String s, boolean defaultValue)
  {
    try
    {
      return Boolean.valueOf(s);
    }
    catch (Exception e){}
    return Boolean.valueOf(defaultValue);
  }
  
  public static String StringToDoubleString(String t)
  {
    try
    {
      if (point==null)
      {
        DeterminePoint();
      }
      return t.replace(point.charAt(0), '.');
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Other->Functions->StringToDoubleString",e);
    }
    return "";
  }
  
  protected static void DeterminePoint()
  {
    Double d=new Double(1.1);
    DecimalFormat df=new DecimalFormat();
    String t=df.format(d);
    point=t.substring(1, 2);
  }
  
  public static String Implode(String delimiter, Object[] objects)
  {
    try
    {
      StringBuffer buf=new StringBuffer();
      for (int i=0;i<objects.length;i++)
      {
        buf.append(objects[i].toString());
        buf.append(delimiter);
      }
      if (buf.length()>0)
      {
        return buf.substring(0, buf.length()-delimiter.length());
      }
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Other->Functions->Implode",e);
    }
    return "";
  }
  
  public static String[] Explode(String delimiter, String s)
  {
    try
    {
      LinkedList<String> list=new LinkedList<String>();
      int pos=0;
      int prevPos=0;
      String pom;
      while ((pos=s.indexOf(delimiter,prevPos))>-1)
      {
        list.add(s.substring(prevPos, pos));
        prevPos=pos+delimiter.length();
      }
      if (prevPos<s.length())
      {
        list.add(s.substring(prevPos, s.length()));
      }
      return list.toArray(new String[0]);
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Other->Functions->Explode",e);
    }
    return new String[0];
  }
  
  public static int CountOccurances(String text, String substring)
  {
    try
    {
      int res=0;
      int pos=0;
      int prevPos=0;
      String pom;
      while ((pos=text.indexOf(substring,prevPos))>-1)
      {
        res++;
        prevPos=pos+substring.length();
      }
      return res;
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Other->Functions->CountOccurances",e);
    }
    return 0;
  }
  
  public static LinkedList<Integer> GetSubstringPositions(String text, String substring)
  {
    try
    {
      LinkedList<Integer> list=new LinkedList<Integer>();
      int pos=0;
      boolean ok;
      while ((pos=text.indexOf(substring, pos))>-1)
      {
        ok=((pos==0) || (notWordDelimiters.indexOf(text.substring(pos-1, pos))==-1));
        ok&=(((pos+substring.length())>=text.length()) || (notWordDelimiters.indexOf(text.substring(pos+substring.length(), pos+substring.length()+1))==-1));
        if (ok)
        {
          list.add(pos);
        }
        pos+=substring.length();
      }
      return list;
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Other->Functions->GetSubstringPositions",e);
    }
    return new LinkedList<Integer>();
  }
  
  public static String ReadFile(File file)
  {
    try
    {
      StringBuffer buf=new StringBuffer();
      FileInputStream fis=new FileInputStream(file);
      InputStreamReader isr=new InputStreamReader(fis);
      BufferedReader br=new BufferedReader(isr);
      while (br.ready())
      {
        buf.append(br.readLine());
        buf.append("\r");
      }
      br.close();
      isr.close();
      fis.close();
      return buf.toString();
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Other->Functions->ReadFile",e);
    }
    return null;
  }
  
  public static String ReadStream(InputStream in)
  {
    try
    {
      StringBuffer buf=new StringBuffer();
      InputStreamReader isr=new InputStreamReader(in);
      BufferedReader br=new BufferedReader(isr);
      while (br.ready())
      {
        buf.append(br.readLine());
        buf.append("\n");
      }
      br.close();
      isr.close();
      return buf.toString();
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Other->Functions->ReadStream",e);
    }
    return null;
  }
  
  public static void SaveToFile(String text, File file)
  {
    try
    {
      FileOutputStream fos=new FileOutputStream(file);
      fos.write(text.getBytes());
      fos.flush();
      fos.close();
    }
    catch (Exception e)
    {
      Global.errorLog.Write("Other->Functions->SaveToFile",e);
    }
  }
  
  public static boolean DeleteDirectory(File path) {
    if( path.exists() ) {
      File[] files = path.listFiles();
      for(int i=0; i<files.length; i++) {
         if(files[i].isDirectory()) {
           DeleteDirectory(files[i]);
         }
         else {
           files[i].delete();
         }
      }
    }
    return( path.delete() );
  }
  
}
