/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package thread;

import algorithm.DistributedAlgorithm;
import algorithm.StopException;
import java.util.Collections;
import java.util.Map;
import network.Node;
import other.AssociativeArray;
import other.Global;
import player.Player;

/**
 *
 * @author Dur
 */
public class NodeThread extends CommunicatingThread 
{
  public Node node;
  public Player player;
  public Map<Object, Object> prop;
  public DistributedAlgorithm distributedAlg=null;
  public boolean createdWithErrors=false;
  
  public NodeThread(Node node, Player player)
  {
    this.node=node;
    this.player=player;
    prop=Collections.synchronizedMap((AssociativeArray<Object, Object>) node.prop.clone());
    try
    {
      distributedAlg=player.network.GetAlgorithm().GetSourceCode().GetDistributedAlgorithm();
      distributedAlg.SetNodeThread(this);
    }
    catch (Exception e)
    {
      createdWithErrors=true;
    }
  }
  
  @Override
  public void run()
  {
    try
    {
      if (distributedAlg!=null)
      {
        distributedAlg.Run();
      }
    }
    catch (StopException e)
    {
      
    }
    catch (Exception e)
    {
      try
      {
        player.WriteException("Node with id="+node.prop.get("id")+" raised exception", e);
      }
      catch (Exception e2)
      {
        Global.errorLog.Write("Error: NodeThread->run", e2);
      }
    }
  }
  
}
